DRAGDROP = { };

DRAGDROP.getItemByCoords = function(tree, x, y, r, c, ch){
	var e;
	try {
		var row = { };
		var col = { };
		var child = { };
		var boxobject = tree.treeBoxObject;
		var maxX = boxobject.x + boxobject.rowWidth;
		if ( TREE.hasVScroll( tree ) ) maxX -= 25;
		//alert ('x' + x + '- bo.x ' + boxobject.x + ' - bo.rw' + boxobject.width);
		if (  x > maxX ) return false;
		boxobject.getCellAt(x, y, row, col, child);
		return row.value > -1 ? tree.contentView.getItemAtIndex( row.value) : false;
	} catch(e) { IO.alert( 'DRAGDROP.getCellByCoords', e ); }
};


DRAGDROP.getDragSession = function(){
	var e;
	try {
		if ( DRAGDROP.dds ) return DRAGDROP.dds;
		return DRAGDROP.dds = ( Components.classes["@mozilla.org/widget/dragservice;1"].getService(Components.interfaces.nsIDragService) ).getCurrentSession();
	} catch(e) { IO.alert( 'DRAGDROP.getDragSession', e ); }
};

DRAGDROP.setTransferData = function (obj){
	var e;
	try {
		var data = new Array(obj);
		var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
		var textWrapper = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
		var transArray = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
		trans.addDataFlavor("text/plain");
		textWrapper.data = 'No Data';
		trans.setTransferData("text/plain", textWrapper, textWrapper.data.length);
		transArray.AppendElement(trans);
		return transArray;
	} catch(e) { IO.alert( 'DRAGDROP.setTransferData', e ); }
};

DRAGDROP.initDragSession = function (ev, obj, func){
	var e;
	try {
		DRAGDROP.dds = false;
		if (typeof func == 'undefined') func = DRAGDROP.setTransferData;
		var transArray = func(obj);
		var ds = Components.classes["@mozilla.org/widget/dragservice;1"].getService(Components.interfaces.nsIDragService);
		var dragmode = ds.DRAGDROP_ACTION_COPY + ds.DRAGDROP_ACTION_MOVE + ds.DRAGDROP_ACTION_LINK;
		// ds.invokeDragSession(obj, transArray, null, dragmode);
		 var region = DRAGDROP.getRegion(ev);
		 var ex;
		 try { ds.invokeDragSessionWithImage(obj, transArray, region, dragmode, null, 0, 0, ev); 
		 } catch(ex) {}
	} catch(e) { IO.alert( 'DRAGDROP.initDragSession', e ); }
};

DRAGDROP.getRegion = function ( ev ){
	var reg = null;
	var e;
	if (ev.originalTarget.localName == "treechildren") {
		var tree = ev.originalTarget.parentNode;
		try {
			reg = Components.classes["@mozilla.org/gfx/region;1"].createInstance(Components.interfaces.nsIScriptableRegion);
			reg.init();
			var obo = tree.treeBoxObject;
			var bo = obo.treeBody.boxObject;
			var sel= obo.view.selection;
			var rowX = bo.x; var rowY = bo.y; var rowHeight = obo.rowHeight; var rowWidth = bo.width;
			for (var i = obo.getFirstVisibleRow(); i <= obo.getLastVisibleRow(); i ++){
				if (sel.isSelected(i)) reg.unionRect(rowX, rowY, rowWidth, rowHeight);
				rowY = rowY + rowHeight;
			}
			reg.intersectRect(bo.x, bo.y, bo.width, bo.height);
		} catch(e) { return null; }
	} 
	return reg;
};

DRAGDROP.activateDragSession = function(cond){
	var e;
	try {
		var ses = DRAGDROP.getDragSession()
		if (ses) ses.canDrop = cond;
	} catch(e) { IO.alert( 'DRAGDROP.activateDragSession', e ); }
};

DRAGDROP.enableDragSession = function(ev, cond ){
	var e;
	try {
	
		var ses = DRAGDROP.getDragSession()
		if (ses){
			var validFlavor = false;
			if ( ses.isDataFlavorSupported("moz/toolbaritem") ) validFlavor = true;
			else if ( ses.isDataFlavorSupported("text/plain") ) validFlavor = true;
			var can = validFlavor && cond;
			ses.canDrop = can;
			if( can ) ev.stopPropagation();
		}
	} catch(e) { IO.alert( 'DRAGDROP.enableDragSession', e ); }
};

// Refers to AJAX, FIELD
CMD = {'internal': {}, prop: {'fpfx': 'dbfield_', 'strings': false} };

CMD.init = function(str){
	if ( typeof str == 'undefined' ) CMD.prop.strings = document.getElementById('strings');
	else CMD.prop.strings = str;
};

CMD.initform = function ( formid ){
	var e;
	try {
		var fields = IO.xpath('//*[id="'+formid+'"]//*[starts-with(@id,"'+CMD.prop.fpfx+'")]', document);
		FIELD.init(CMD.prop.fpfx, fields);
		FIELD.reset(formid);
	} catch(e) {
		IO.alert( 'CMD.form2command', e );
	}
};

CMD.presetForm = function( fldsfxs ){
	for (var x in fldsfxs){
		var fid = CMD.prop.fpfx + x;
		var f = document.getElementById(fid);
		if( f ) FIELD.set(f, fldsfxs[x]);
	}
};

CMD.send = function( method, parameters, funcOK, funcKO) {
	var e;
	try {
		if (typeof method == 'string' ) method = [ method ];
		if (typeof funcKO == 'undefined' ) funcKO = CMD.unsuccess;
		var d = new AJAX.doc();
		d.handleStatus = false;
		for ( var i = 0; i < method.length; i++ ){
			var c = d.newCommand( method );
			for (var p in parameters) c.newParam(p, parameters[p]);
		}
		d.send( funcOK, funcKO );
	} catch(e) {
		IO.alert( 'CMD.send', e );
	}
};

CMD.sendform = function( method, form, funcOK, funcKO) {
	var e;
	try {
		if (typeof method == 'string' ) method = [ method ];
		if (typeof funcKO == 'undefined' ) funcKO = CMD.unsuccess;
		var d = new AJAX.doc();
		d.handleStatus = false;
		for ( var i = 0; i < method.length; i++ ){
			var c = d.newCommand( method );
			CMD.form2command(c, form);
		}
		d.send( funcOK, funcKO );
	} catch(e) {
		IO.alert( 'CMD.sendform', e );
	}
};

CMD.form2command = function( cmd, form) {
	var e;
	try {
		var fields;
		if (form instanceof Array) fields = form;
		else {
			var xp = '';
			if (form) xp = '//*[@id="'+form+'"]';
			xp = xp + '//*[starts-with(@id,"'+CMD.prop.fpfx+'")]';
			fields = IO.xpath(xp, document);
		}
		return CMD.internal.form2command( cmd, fields);
	} catch(e) {
		IO.alert( 'CMD.form2command', e );
	}
};


CMD.internal.form2command = function( cmd, fields) {
	var e;
	try {
		if (!fields instanceof Array) return false;
		var len = CMD.prop.fpfx.length;
		for ( var i = 0; i < fields.length; i++ ) {
			var n = fields[i];
			var v = FIELD.get(n);
			var add = n.hasAttribute('dontSend') ? !n.getAttribute('dontSend') : true;
			if (add) cmd.newParam( n.getAttribute('id').substr(len), v );
		}
		return true;
	} catch(e) {
		IO.alert( 'BMD.internal.form2command', e );
	}
};

CMD.success = function( doc ) {
	var e;
	try {
		var success = parseInt(doc.documentElement.getAttribute('status')) == 0;
		if (!success) CMD.internal.applicationError( doc );
		return success;
	} catch(e) {
		IO.alert( 'CMD.success', e );
	}
};

CMD.internal.applicationError = function( doc ) {
	var e;
	try {
		var desc = '';
		if (typeof doc == 'undefined'){
			IO.alert(CMD.internal.buildString( 'errorHeader'), CMD.internal.buildString('unknownErrorBody'));
			return;
		}
		var x = doc.documentElement;
		desc = x.hasAttribute('description') ? x.getAttribute('description') : CMD.internal.buildString( 'unknownError');
		IO.alert(CMD.internal.buildString( 'errorHeader'), CMD.internal.buildString('applicationError', [desc]));
	} catch(e) {
		IO.alert( 'CMD.internal.applicationError', e );
	}
};

CMD.unsuccess = CMD.internal.applicationError;

CMD.response2form = function( doc, baseXPath ) {
	var e;
	try {
		if ( typeof baseXPath == 'undefined') baseXPath = '/root/arrayitem/results/arrayitem';
		var attrs = IO.xpath( baseXPath + '/@*', doc);
		for ( var i = 0; i < attrs.length; i++ ) {
			var x = attrs[i];
			var n = document.getElementById( CMD.prop.fpfx + x.name );
			if ( n ) FIELD.set( n, x.value );
		}
	} catch(e) {
		IO.alert( 'CMD.response2form', e );
	}
};

CMD.checkDlgClose = function() { return IO.getPref("thisapp.lastDialogSuccess");  };

CMD.internal.buildString = function(s, p ) {
	var e;
	try {
		return ( typeof p == 'undefined' ) ? CMD.prop.strings.getString( s ) : CMD.prop.strings.getFormattedString( s, p );
	} catch(e) { return s; }
};


CMD.buildString = function(obj, s, p ) {
	var e;
	try {
		return ( typeof p == 'undefined' ) ? obj.getString( s ) : obj.getFormattedString( s, p );
	} catch(e) { return s; }
};

CMD.debugForm = function(obj){
	var prpstr = '';
	var j = 0;
	for ( var i = 0; i < obj.length; i++ ) {
		var n = obj[i];
		prpstr += i + '. ' + n.getAttribute('id') + ': ' + n.getAttribute('value') + ' (' + obj[i].value +')\r\n';
		j++; 
		if ( j == 10){
			alert(prpstr);
			prpstr = '';
			j = 0;
		}
	}
	alert (prpstr);
};

CMD.debugObjects = function(obj){
	var prpstr = '';
	var i = 0;
	for (x in obj){ 
		prpstr += (i++) + '. ' + x + ':' + obj[x] + '\r\n';
		if ( i == 10){
			alert(prpstr);
			prpstr = '';
			i = 0;
		}
	}
	alert (prpstr);
};

DLG = {'internal': {}, prop: {}, strings: false };

DLG.init = function( ) {
	var e;
	try {
		CMD.init();
		DLG.prop.fields = IO.xpath("//*[starts-with(@id,'"+ CMD.prop.fpfx +"')]", document );
		var root = document.documentElement;
		var rootn = root.nodeName.toLowerCase();
		switch (rootn) {
			case 'wizard'	:	DLG.prop.isWizard = true;
						DLG.prop.w = root;
						DLG.prop.finishButton = root.getButton('finish');
						break;
			case 'dialog'	:	DLG.prop.isDialog = true;
						DLG.prop.w = root;
						DLG.prop.okButton = DLG.prop.w.getButton("accept");
						DLG.prop.cancelButton = DLG.prop.w.getButton("cancel");
						break;
			case 'prefwindow' :	window.moveToAlertPosition();
						break;
		}
		IO.setPref("thisapp.lastDialogSuccess", false);
	} catch(e) {
		IO.alert( 'DLG.init', e );
	}
};

DLG.send = function( method ) {
	var e;
	try {
		if (typeof method == 'string' ) method = [ method ];
		DLG.internal.transButtons( true );
		CMD.sendform(method, DLG.prop.fields, DLG.internal.ok, DLG.internal.ko);
	} catch (e) {
		IO.alert( 'DLG.send', e );
	}
};

DLG.close = function( success ) { setTimeout('DLG.internal.close('+( !!(success) ) +')', 100 ); };

DLG.internal.close = function( retValue ) {
	IO.setPref("thisapp.lastDialogSuccess", !!(retValue));
	if (DLG.prop.isWizard ) {
		DLG.prop.w.setAttribute('onwizardcancel', 'return true;');
		DLG.prop.w.cancel();
	} else if ( DLG.prop.isDialog ) {
		DLG.prop.w.setAttribute('ondialogcancel', 'return true;');
		DLG.prop.w.cancelDialog();
	}
};

DLG.okNoClose = function( doc ) {
	var e;
	try {
		if (! CMD.success( doc )) DLG.internal.ko( doc )
	} catch(e) {
		IO.alert( 'DLG.okNoClose', e );
	}
};

DLG.internal.ko = function( doc ) {
	var e;
	try {
		DLG.internal.transButtons( false );
		CMD.unsuccess();
	} catch(e) {
		IO.alert( 'DLG.internal.ko', e );
	}
};

DLG.internal.ok = function( doc ) {
	var e;
	try {
		if (! CMD.success( doc )) DLG.internal.ko( doc )
		DLG.close( true );
	} catch(e) {
		IO.alert( 'DLG.internal.ok', e );
	}
};

DLG.internal.transButtons = function( status ) {
	var e;
	try {
		if (DLG.prop.isWizard ) {
			DLG.prop.w.canAdvance = ! status;
			DLG.prop.w.canRewind = ! status;
			DLG.prop.finishButton.disabled = status;
		} else if ( DLG.prop.isDialog ) {
			DLG.prop.okButton.setAttribute('disabled', status);
		}
	} catch (e) {
		IO.alert( 'DLG.internal.transButtons', e );
	}
};

DLG.setField = function (fid, fvl) {
	var x = document.getElementById(CMD.prop.fpfx + fid);
	if (x) FIELD.set(x, fvl);
};

MASKFIELD = { 'costants': {} };

MASKFIELD.constants = {
	'RNode':	256,
	'WNode':	128,
	'XNode':	64,
	'RUsrs':	32,
	'WUsrs':	16,
	'XUsrs':	8,
	'RCont':	4,
	'WCont':	2,
	'XCont':	1
};

MASKFIELD.simpleconstants = {
	'Node':	448,
	'Usrs':	56,
	'Cont':	7
};

MASKFIELD.checkPerm = function( obj ){
	var e;
	try {
		var cm = document.getElementById(CMD.prop.fpfx + 'cmask');
		if (cm){
			var y = parseInt(cm.getAttribute('value'), 8);
			var x = obj.hasAttribute('value') ? obj.getAttribute('value') : 0;
			x = isNaN(parseInt(x, 10)) ? 0 : parseInt(x, 10);
			x = y + (obj.checked ? -x : x);
			x = '0' + x.toString(8);
			FIELD.set(cm, x);
		}
	} catch(e) { IO.alert( 'MASKFIELD.checkPerm', e ); }
};

MASKFIELD.get = function (obj, isAdmin) {
	var x = '0777';
	if ( !isAdmin ) x = obj.hasAttribute('cmask') ? obj.getAttribute('cmask') : '0000';
	return isNaN(parseInt(x, 8)) ? 0 : parseInt(x, 8);
};

MASKFIELD.setPerm = function(field, pfx){
	var e;
	try {
		var cm = document.getElementById(CMD.prop.fpfx + field);
		if (cm){
			var cmv = cm.getAttribute('value');
			cmv = isNaN(parseInt(cmv, 8)) ? 0 : parseInt(cmv, 8)
			for (x in MASKFIELD.constants){
				var z = document.getElementById(pfx + x);
				if ( z ) {
					var y = (cmv & MASKFIELD.constants[x]) == MASKFIELD.constants[x];
					z.checked = y;
					z.getAttribute('checked', y);
				}
			}
		}
	} catch(e) { IO.alert( 'MASKFIELD.setPerm', e ); }
};

MASKFIELD.setSimplePerm = function(field, pfx){
	var e;
	try {
		var cm = document.getElementById(CMD.prop.fpfx + field);
		if (cm){
			var cmv = cm.getAttribute('value');
			cmv = isNaN(parseInt(cmv, 8)) ? 0 : parseInt(cmv, 8)
			for (x in MASKFIELD.simpleconstants){
				var z = document.getElementById(pfx + x);
				if ( z ) {
					var y = (cmv & MASKFIELD.constants[x]) == MASKFIELD.constants[x];
					z.checked = y;
					z.getAttribute('checked', y);
				}
			}
		}
	} catch(e) { IO.alert( 'MASKFIELD.setPerm', e ); }
};

MASKFIELD.can = function (mask, what){
	return (mask & MASKFIELD.constants[what]) == MASKFIELD.constants[what];
};

MASKFIELD.apply = function ( mask, cmdpfx ) {
	if(typeof cmdpfx == 'undefined') cmdpfx = '';
	for (var i in MASKFIELD.constants) {
		var y = (mask & MASKFIELD.constants[i]) == MASKFIELD.constants[i];
		var x = document.getElementById( i + cmdpfx + 'Cmd');
		if ( x ) x.setAttribute('disabled', !y );
		var x = document.getElementById( i + cmdpfx + 'Btn');
		if ( x ) { x.setAttribute('disabled', !y ); x.setAttribute('collapsed', !y ); }
		var x = document.getElementById( i + cmdpfx +'Box');
		if ( x ) x.setAttribute('collapsed', !y );
	}
};

MASKFIELD.disable = function(objpfx, tmout){
	var cobj = document.getElementById(objpfx + 'Cmd');
	if (cobj) cobj.setAttribute('disabled', true);
	else alert('Non ci sta:' + objpfx);
	var mobj = document.getElementById(objpfx + 'Btn');
	if (mobj) cobj.setAttribute('disabled', true);
	else alert('Non ci sta:' + objpfx);
	if ( typeof tmout != 'undefined' ) setTimeout( "MASKFIELD.enable('"+objpfx+"');", tmout );
};


MASKFIELD.suMode = function ( ) {
	for (var i in MASKFIELD.constants) {
		var x = document.getElementById( i + 'Cmd');
		if ( x ) x.setAttribute('disabled', false );
		var y = document.getElementById( i + 'Btn');
		if ( y ) { y.setAttribute('disabled', false ); y.setAttribute('collapsed', false ); }
		var z = document.getElementById( i + 'Box');
		if ( z ) z.setAttribute('collapsed', false );
	}
};

MASKFIELD.enable = function(objpfx){
	var cobj = document.getElementById(objpfx + 'Cmd');
	if (cobj) cobj.setAttribute('disabled', false);
	var mobj = document.getElementById(objpfx + 'Btn');
	if (mobj) cobj.setAttribute('disabled', false);
};