var MAIN = { 'internal' : {} }

MAIN.prop = {
		autoStart	: false,
		autoStartTime	: 10,
		'defined'	: true,
		tabPanel	: 0,
		tabServer	: 1,
		tabAuthor	: 2,
		tabInfo		: 3
	};
MAIN.IDs = {
		w		: 'mainApplicationWindow',
		loggedIn	: 'loggedIn',
		panelName	: 'prefPanelName',
		serverIname	: 'prefServerAddress',
		serverPort	: 'prefServerPort',
		serverBasedir	: 'prefServerBaseDir',
		serverVrfyRes	: 'serverVerificationResult',
		serverVrfyResOk	: 'serverVerificationResultOk',
		severSaveButt	: 'prefsSaveServer',
		serverVrfyButt	: 'prefsVrfyServer',
		serverResetButt	: 'prefsResetServer',
		starterDeck	: 'starterDeck',
		starterProgress	: 'starterProgress',
		strings		: 'strings',
		tabBox		: 'prefsTabBox',
		authorDeck	: 'prefsAuthorDeck',
		userName	: 'prefPanelUsername',
		password	: 'prefPanelPassword',
		loginButton	: 'prefsLoginButt',
		logoImage	: 'logoImage',
		disableStart	: 'disableAutostart',
		disableWatchdog	: 'disableWatchdog'
	};

MAIN.init = function(w) {
		var e;
		try {
			if (typeof w == 'undefined') w = window;
			MAIN.prop.w = w;
			MAIN.prop.w.name = 'bastetClient';
			setTimeout('MAIN.internal.init()', 1 );
		} catch(e) {
			IO.alert( 'MAIN.init', e );
		}
	};

MAIN.deleteCache = function() {
		var e;
		try {
			var uc = IO.getUserChrome();
			uc = uc.path + IO.prop.sep;
			IO.rmdir( 'cacheDir', uc, true, true );
			IO.rmdir( 'data', uc, true, true );
		} catch(e) {
			IO.alert( 'MAIN.deleteCache', e );
		}
	};

MAIN.internal.init = function() {
		var e;
		try {
			var w = MAIN.prop.w;
			for (var i in MAIN.IDs) MAIN.prop[i] = w.document.getElementById( MAIN.IDs[i] );
			MAIN.deleteCache();
			MAIN.resetServer();
			MAIN.resetPanel();
			//setTimeout( 'centerWindowOnScreen()',1);
			MAIN.internal.check4autostart();
			if ( AJAX.getUser() ) MAIN.prop.userName.value = AJAX.getUser();
			MAIN.canPressLoginButton();
			MAIN.prop.userName.addEventListener( 'keypress', MAIN.internal.enterLogin, false );
			MAIN.prop.password.addEventListener( 'keypress', MAIN.internal.enterLogin, false );
			IO.setPref('network.protocol-handler.warn-external.http', false);
			IO.setPref('browser.places.importBookmarksHTML', false );
			IO.setPref('browser.places.importDefaults', false );
			if (IO.getPref('thisapp.auth.session')) IO.delPref('thisapp.auth.session');
			IO.fixPref('network.proxy.http_port',8080)
			var pport = IO.getPref('network.proxy.http_port');
			if ( ( ! pport ) || ( pport == 0) ) IO.setPref('network.proxy.http_port',8080);
// 			setTimeout('window.fullScreen = true;',1); 
// 			w.sizeToContent();
		} catch(e) {
			IO.alert( 'MAIN.internal.init', e );
		}
	};

MAIN.internal.check4autostart = function() {
		var e;
		try {
			var x = IO.getPref('thisapp.autostart.disabled');
			if (typeof x == 'undefined' ){
				x = false;
				IO.setPref('thisapp.autostart.disabled', x);
			}
			MAIN.prop.disableStart.setAttribute('checked', x);
			var w = IO.getPref('thisapp.watchdog.disabled');
			if (typeof w == 'undefined' ){
				w = false;
				IO.setPref('thisapp.watchdog.disabled', w);
			}
			MAIN.prop.disableWatchdog.setAttribute('checked', w);
			MAIN.prop.disableWatchdog.style.visibility = x ? 'hidden' : 'visible';
			if ( MAIN.panelWatchdog ) {
				clearInterval( MAIN.panelWatchdog );
				MAIN.panelWatchdog = false;
			}
			if ( x ) {
				MAIN.prop.starterDeck.setAttribute('selectedIndex', 0);
			} else {
				setTimeout('MAIN.autoStart()', 5 );
			}
		} catch(e) {
			IO.alert( 'MAIN.internal.check4autostart', e );
		}
	};

MAIN.internal.panelWatchdog = function() {
		var e;
		try {
			var w = IO.getWindowByName( 'panelWindow'  );
			if ( ! w ) setTimeout('MAIN.internal.check4autostart()', 5 );
		} catch(e) {
			IO.alert( 'MAIN.internal.panelWatchdog', e );
		}
	};

MAIN.disableAutostart = function() {
		var x = MAIN.prop.disableStart.getAttribute('checked');
		IO.setPref('thisapp.autostart.disabled', x);
		MAIN.prop.disableWatchdog.style.visibility = x ? 'hidden' : 'visible';
		if ( x ) MAIN.cancelAS();
	};

MAIN.disableWatchdog = function() {
		var x = MAIN.prop.disableWatchdog.getAttribute('checked');
		if ( x ) if ( MAIN.panelWatchdog ) {
			clearInterval( MAIN.panelWatchdog );
			MAIN.panelWatchdog = false;
		}
		IO.setPref('thisapp.watchdog.disabled', x);
	};

MAIN.fetchPanelsList = function( popup ) {
		var e;
		try {
			var uri = IO.getPref('thisapp.server.baseuri');
			if ( ! uri ) return false;
			var monitors = IO.xpath( '//monitor', XML.load( uri + 'static/panels.xml?refetchToken=' + Math.random() ) );
			XML.zapAllChilds( popup );
			for ( var i = 0; i < monitors.length; i++ ) {
				var mname = monitors[i].getAttribute('name');
				popup.appendChild( XML.createNode( 'menuitem', '', {'label':mname, 'value':mname }, document ) );
			}
			return true;
		} catch(e) {
			return false;
		}
	};

MAIN.testClick = function(evt) {
		var e;
		try {
			// MAIN.prop.logoImage.addEventListener( 'click', MAIN.testClick, false );
			var x = evt.layerX - evt.target.boxObject.x;
			var y = evt.layerY - evt.target.boxObject.y;
			alert( x + ' - ' + y );
		} catch(e) {
			IO.alert( 'MAIN.test', e );
		}
	};

MAIN.autoStart = function() {
		var e;
		try {
			if ( ! MAIN.internal.canAutoStart() ) return;
			var uri = MAIN.internal.calcBaseURI() + 'version.xml?refetchToken=' + Math.random();
			XML.load( uri, MAIN.internal.autoStart, MAIN.internal.verifyServerFailure );
		} catch(e) {
			IO.alert( 'MAIN.autoStart', e );
		}
	};

MAIN.internal.autoStart = function( doc ) {
		var e;
		try {
			MAIN.prop.starterDeck.selectedIndex = 1;
			var i = setInterval( 'MAIN.internal.AS()', parseInt( 1000 / MAIN.prop.autoStartTime ) );
			MAIN.prop.autoStart = { 'int' : i, 'prog' : 0 };
		} catch(e) {
			IO.alert( 'MAIN.internal.autoStart', e );
		}
	};

MAIN.internal.AS = function() {
		var e;
		try {
			MAIN.prop.autoStart.prog++;
			var x = MAIN.prop.autoStart.prog;
			if ( x >= 100 ) {
				MAIN.cancelAS();
				MAIN.startPanel();
			} else {
				MAIN.prop.starterProgress.value = x;
			}
		} catch(e) {
			IO.alert( 'MAIN.internal.AS', e );
		}
	};

MAIN.cancelAS = function() {
		MAIN.prop.starterDeck.selectedIndex = 0;
		if (MAIN.prop.autoStart.int) clearInterval( MAIN.prop.autoStart.int );
		MAIN.prop.autoStart = false;
	};

MAIN.internal.canAutoStart = function() {
		var e;
		try {
			if ( MAIN.prop.panelName.value == '' ) {
				MAIN.prop.tabBox.selectedIndex = MAIN.prop.tabPanel;
				MAIN.prop.panelName.focus();
				return false;
			}
			if ( MAIN.prop.serverIname.value == '' ) {
				MAIN.prop.tabBox.selectedIndex = MAIN.prop.tabServer;
				MAIN.prop.serverIname.focus();
				return false;
			}
			if ( MAIN.prop.serverPort.value == '' ) {
				MAIN.prop.tabBox.selectedIndex = MAIN.prop.tabServer;
				MAIN.prop.serverPort.focus();
				return false;
			}
			if ( MAIN.prop.serverBasedir.value == '' ) {
				MAIN.prop.tabBox.selectedIndex = MAIN.prop.tabServer;
				MAIN.prop.serverBasedir.focus();
				return false;
			}
			if ( typeof IO.getPref('thisapp.server.iname') == 'undefined' ) {
				MAIN.prop.tabBox.selectedIndex = MAIN.prop.tabServer;
				MAIN.prop.serverIname.focus();
				return false;
			}
			return true;
		} catch(e) {
			IO.alert( 'MAIN.internal.canAutoStart', e );
		}
	};

MAIN.chServerData = function() {
		MAIN.prop.severSaveButt.disabled = true;
		MAIN.prop.serverVrfyButt.disabled = false;
		MAIN.prop.serverResetButt.disabled = false;
	};

MAIN.verifyServer = function() {
		var e;
		try {
			var uri = MAIN.internal.calcBaseURI();
			MAIN.prop.serverVrfyRes.selectedIndex = 1;
			XML.load( uri + 'version.xml', MAIN.internal.verifyServerSuccess, MAIN.internal.verifyServerFailure );
		} catch(e) {
			IO.alert( 'MAIN.verifyServer', e );
		}
	};

MAIN.internal.verifyServerFailure = function( uri ) {
		var e;
		try {
			MAIN.prop.tabBox.selectedIndex = MAIN.prop.tabServer;
			MAIN.prop.serverVrfyRes.selectedIndex = 3;
			MAIN.prop.severSaveButt.disabled = true;
		} catch(e) {
			IO.alert( 'MAIN.internal.verifyServerFailure', e );
		}
	};

MAIN.internal.verifyServerSuccess = function( doc ) {
		var e;
		try {
			var sv = doc.documentElement.getAttribute('version');
			var svlabel = MAIN.prop.strings.getString('serverVersion')+': '+sv;
			var svn = parseFloat( sv );
			if ( svn < 2.1 ) {
				if ( svn < 2 ) {
					IO.alert( svlabel, MAIN.prop.strings.getString('warnServerPre2') );
				} else {
					IO.alert( svlabel, MAIN.prop.strings.getString('warnServerPre2.1') );
				}
			}
			MAIN.prop.serverVrfyResOk.setAttribute('value', MAIN.prop.strings.getString('okServerV')+' '+sv );
			MAIN.prop.serverVrfyRes.selectedIndex = 2;
			MAIN.prop.severSaveButt.disabled = false;
			IO.setPref('thisapp.server.version', sv );
		} catch(e) {
			IO.alert( 'MAIN.internal.verifyServerOk', e );
		}
	};


MAIN.internal.calcBaseURI = function() {
		var e;
		try {
			var uri = 'http://';
			var tmp = MAIN.prop.serverIname.value.replace(/\//g,'');
			if ( MAIN.prop.serverIname.value != tmp ) MAIN.prop.serverIname.value = tmp;
			uri += tmp;
			tmp = parseInt(MAIN.prop.serverPort.value);
			if ( isNaN( tmp ) ) tmp = 80;
			if ( parseInt( MAIN.prop.serverPort.value ) != tmp ) MAIN.prop.serverPort.value = String( tmp );
			if ( tmp != 80 ) uri += ':' + tmp;
			uri += '/';
			tmp = MAIN.prop.serverBasedir.value.replace(/^\//,'').replace(/\/$/,'');
			if ( tmp == '' ) tmp = 'bastet';
			if ( MAIN.prop.serverBasedir.value != tmp ) MAIN.prop.serverBasedir.value = tmp;
			uri += tmp + '/';
			IO.setPref( 'thisapp.server.baseuri', uri );
			return uri;
		} catch(e) {
			IO.alert( 'MAIN.internal.baseURI', e );
		}
	};

MAIN.saveServer = function() {
		var e;
		try {
			IO.setPref('thisapp.server.iname', MAIN.prop.serverIname.value );
			MAIN.prop.serverIname.setAttribute('value',MAIN.prop.serverIname.value);
			IO.setPref('thisapp.server.port', MAIN.prop.serverPort.value );
			MAIN.prop.serverPort.setAttribute('value',MAIN.prop.serverPort.value);
			IO.setPref('thisapp.server.basedir', MAIN.prop.serverBasedir.value );
			MAIN.prop.serverBasedir.setAttribute('value',MAIN.prop.serverBasedir.value);
			MAIN.prop.severSaveButt.disabled = true;
// 			MAIN.prop.serverVrfyButt.disabled = true;
			MAIN.prop.serverResetButt.disabled = true;
			MAIN.internal.resetLoginURI();
		} catch(e) {
			IO.alert( 'MAIN.saveServer', e );
		}
	};

MAIN.resetServer = function() {
		var e;
		try {
			
			var tmp = IO.getPref('thisapp.server.iname' );
			if ( typeof tmp == 'undefined' ) tmp = document.getElementById('defaultServer').getAttribute('value');
			MAIN.prop.serverIname.value = tmp;
			MAIN.prop.serverIname.setAttribute('value', tmp);
			tmp = IO.getPref('thisapp.server.port');
			if ( typeof tmp == 'undefined' ) tmp = document.getElementById('defaultPort').getAttribute('value');
			MAIN.prop.serverPort.value = tmp;
			MAIN.prop.serverPort.setAttribute('value',tmp);
			tmp = IO.getPref('thisapp.server.basedir');
			if ( typeof tmp == 'undefined' ) tmp = document.getElementById('defaultRealm').getAttribute('value');
			MAIN.prop.serverBasedir.value = tmp;
			MAIN.prop.serverBasedir.setAttribute('value', tmp);
			MAIN.internal.resetLoginURI();
		} catch(e) {
			IO.alert( 'MAIN.resetServer', e );
		}
	};

MAIN.internal.resetLoginURI = function() {
		var e;
		try {
			var loginuri = 'http://' + MAIN.prop.serverIname.value + ':' + MAIN.prop.serverPort.value + '/' + MAIN.prop.serverBasedir.value + '/login.cgi';
			AJAX.setLoginUri( loginuri );
			IO.setPref('thisapp.auth.altajax','http://' + MAIN.prop.serverIname.value + ':' + MAIN.prop.serverPort.value + '/' + MAIN.prop.serverBasedir.value + '/panel.cgi')
		} catch(e) {
			IO.alert( 'MAIN.internal.resetLoginURI', e );
		}
	};

MAIN.resetPanel = function() {
		var e;
		try {
			var tmp = IO.getPref('thisapp.panel.name' );
			if ( typeof tmp == 'undefined' ) tmp = '';
			if ( tmp == '' ) tmp = 'default';
			MAIN.prop.panelName.value = tmp;
			MAIN.prop.panelName.setAttribute('value', tmp);
		} catch(e) {
			IO.alert( 'MAIN.resetPanel', e );
		}
	};

MAIN.setPanel = function() {
		var e;
		try {
			MAIN.prop.panelName.setAttribute('value', MAIN.prop.panelName.value);
			IO.setPref('thisapp.panel.name', MAIN.prop.panelName.value );
		} catch(e) {
			IO.alert( 'MAIN.setPanel', e );
		}
	};

MAIN.startPanel = function() {
		var e;
		try {
			if ( ! MAIN.internal.canAutoStart() ) {
				var t = MAIN.prop.strings.getString('accessKoTitle');
				var b = MAIN.prop.strings.getString('accessKoBody');
				IO.alert( t, b );
				return;
			}
			MAIN.setPanel();
// 			MAIN.stage = window.openDialog('chrome://panel/content/main.xul','panelWindow',"chrome,dependent,titlebar=no,top=0,left=0,width="+screen.height+",height="+screen.height+",fullscreen=yes" );
			var x = IO.getPref('thisapp.watchdog.disabled');
			if (typeof x == 'undefined' ){
				x = false;
				IO.setPref('thisapp.watchdog.disabled', x);
			}
			if ( ! x ) MAIN.panelWatchdog = setInterval('MAIN.internal.panelWatchdog()', 10000 );
			MAIN.stage = window.open('chrome://panel/content/main.xul','panelWindow',"chrome,dependent,alwaysRaised,titlebar=no,top=0,left=0,width=1024,height=768,fullscreen=yes" );
			setTimeout("MAIN.stage.fullScreen = true;",1);
		} catch(e) {
			IO.alert( 'MAIN.startPanel', e );
		}
	};

MAIN.login = function() {
		var e;
		try {
			MAIN.prop.loginButton.setAttribute( 'disabled', true);
			LOGIN.login( MAIN.prop.userName.value, MAIN.prop.password.value, MAIN.internal.loginOk, MAIN.internal.loginFailure );
		} catch(e) {
			IO.alert( 'MAIN.login', e );
		}
	};

MAIN.canPressLoginButton = function() {
		var e;
		try {
			var cannotPress = ( ( MAIN.prop.userName.value.search(/^[^ @]+\@[^ @]+$/) != 0 ) || ( MAIN.prop.password.value == '' ) );
			MAIN.prop.loginButton.setAttribute('disabled', cannotPress );
			return ! cannotPress;
		} catch(e) {
			IO.alert( 'MAIN.canPressLoginButton', e );
		}
	};

MAIN.internal.enterLogin = function(evt) {
		var e;
		try {
			if ( evt.keyCode == evt.DOM_VK_RETURN ) if ( MAIN.canPressLoginButton() ) MAIN.prop.loginButton.doCommand();
		} catch(e) {
			IO.alert( 'MAIN.internal.enterLogin', e );
		}
	};

MAIN.internal.loginFailure = function() {
		var e;
		try {
			MAIN.prop.loginButton.setAttribute( 'disabled', false);
			IO.alert( 'Error', 'Login failure' );
		} catch(e) {
			IO.alert( 'MAIN.internal.loginFailure', e );
		}
	};

MAIN.internal.loginOk = function() {
		var e;
		try {
			var d = new AJAX.doc();
			d.newCommand('getUserGlobalAccess');
			d.send( MAIN.internal.checkAuth, MAIN.internal.checkAuthFailure );
		} catch(e) {
			IO.alert( 'MAIN.internal.loginFailure', e );
		}
	};

MAIN.closeEveryOtherWindow = function() {
		var e;
		var allW = IO.listWindows();
		for ( var i = 0; i < allW.length; i++ ) {
			var w = allW[i];
			if ( w.name == 'bastetClient' ) {
				w.focus();
			} else {
				try {
					w.close();
				} catch(e) {
				}
			}
		}
		allW = IO.listWindows();
		if ( allW.length > 1 ) setTimeout('MAIN.closeEveryOtherWindow()',1)
	};

MAIN.logout = function() {
		var e;
		try {
			MAIN.closeEveryOtherWindow();
			LOGIN.logout();
			MAIN.deleteCache();
			MAIN.prop.loggedIn.setAttribute( 'value', 0);
			//MAIN.prop.authorDeck.setAttribute('selectedIndex', 0);
			MAIN.prop.password.value = '';
			MAIN.prop.password.focus();
		} catch(e) {
			IO.alert( 'MAIN.logout', e );
		}
	};

MAIN.internal.checkAuthFailure = function( doc ) {
		alert( IO.internal.xml2string( doc ) );
	};

MAIN.internal.checkAuth = function ( doc ) {
		var e;
		try {
			var auth = IO.xpath('/root/arrayitem[@command="getUserGlobalAccess"]/results/arrayitem', doc)[0];
			if (typeof auth == undefined) return;
			var canAuth	= ( auth.getAttribute('fcanauthor') == 'Y' );
			var canBadmin	= ( auth.getAttribute('fcanbadmin')  == 'Y' );
			var canUadmin	= ( auth.getAttribute('fcanuadmin')  == 'Y' );
			var isSuper	= ( auth.getAttribute('fisadmin')  == 'Y' );
			IO.setPref('thisapp.author.user', auth.getAttribute('suser'));
			IO.setPref('thisapp.author.can.broadcastAdmin', canBadmin );
			IO.setPref('thisapp.author.can.userAdmin', canUadmin );
			IO.setPref('thisapp.author.can.author', canAuth );
			IO.setPref('thisapp.author.superuser', isSuper );
			with ( MAIN.prop.loggedIn ) {
				setAttribute( 'canBadmin', canBadmin || isSuper );
				setAttribute( 'canUadmin', canUadmin || isSuper );
				setAttribute( 'canAuth',   canAuth  || isSuper);
				setAttribute( 'value', 1 );
			}
			//MAIN.prop.authorDeck.setAttribute('selectedIndex', 1);
		} catch(e) {
			IO.alert( 'MAIN.internal.checkAuth', e );
		}
	};

MAIN.admin = function (pfx) {	MAIN.internal.openAuthoringEnvironment(pfx+'admin'); };

MAIN.author = function () {	MAIN.internal.openAuthoringEnvironment('author'); };

MAIN.internal.openAuthoringEnvironment = function ( fname ){
		var e;
		try {
			var wname = fname+'Window';
			var w =IO.getWindowByName( wname  );
			if ( w ) {
				w.focus();
			} else {
				var uri = 'chrome://author/content/'+fname+'.xul';
				window.open( uri, wname,"chrome,dependent,resizable=1" );
			}
		} catch(e) {
			IO.alert( 'MAIN.internal.openAuthoringEnvironment', e );
		}
	};


/* ----------- PROGRESS LISTENER ------------ */

MAIN.listener = {};

MAIN.listener.prop = {
	'STATE_START'	: Components.interfaces.nsIWebProgressListener.STATE_START,
	'STATE_STOP'	: Components.interfaces.nsIWebProgressListener.STATE_STOP,
	'STATE_WINDOW'	: Components.interfaces.nsIWebProgressListener.STATE_IS_WINDOW,
	'STATE_NETWORK'	: Components.interfaces.nsIWebProgressListener.STATE_IS_NETWORK
};

MAIN.listener.QueryInterface = function(aIID) {
		if (aIID.equals(Components.interfaces.nsIWebProgressListener) || aIID.equals(Components.interfaces.nsISupportsWeakReference) || aIID.equals(Components.interfaces.nsISupports)) return this;
		throw Components.results.NS_NOINTERFACE;
	};

MAIN.listener.onStateChange = function(aProgress, aRequest, aFlag, aStatus) {
		if (aFlag & MAIN.listener.prop.STATE_START) {
			// This fires when the load event is initiated
		} else {
			if (aFlag & MAIN.listener.prop.STATE_STOP) {
				//if ( aFlag & MAIN.listener.prop.STATE_WINDOW ) {
					// This fires when ALL load finish
				if ( aFlag & MAIN.listener.prop.STATE_NETWORK ) {
					MAIN.internal.continueLoading();
				} else {
					// This fires when a load finishes
				}
			}
		}
		return 0;
	};

// This fires when the location bar changes i.e load event is confirmed or when the user switches tabs
MAIN.listener.onLocationChange = function(aProgress, aRequest, aURI) { return 0 };

// For definitions of the remaining functions see XulPlanet.com
MAIN.listener.onProgressChange    = function() { return 0 };
MAIN.listener.onStatusChange      = function() { return 0 };
MAIN.listener.onSecurityChange    = function() { return 0 };
MAIN.listener.onLinkIconAvailable = function() { return 0 };

/* -------- FIX HTML TOOLTIP ------------- */

MAIN.FillInHTMLTooltip = function(tipElement) {
		var retVal = false;
		if (tipElement.namespaceURI == "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul") return retVal;
		const XLinkNS = "http://www.w3.org/1999/xlink";
		var titleText = null;
		var XLinkTitleText = null;
		while (!titleText && !XLinkTitleText && tipElement) {
			if (tipElement.nodeType == Node.ELEMENT_NODE) {
				titleText = tipElement.getAttribute("title");
				XLinkTitleText = tipElement.getAttributeNS(XLinkNS, "title");
			}
			tipElement = tipElement.parentNode;
		}
		var texts = [titleText, XLinkTitleText];
		var tipNode = document.getElementById("aHTMLTooltip");
		for (var i = 0; i < texts.length; ++i) {
			var t = texts[i];
			if (t && t.search(/\S/) >= 0) {
				tipNode.setAttribute("label", t);
				retVal = true;
			}
		}
		return retVal;
	};

