var FIELD = {'internal' : {} };

FIELD.prop = {
	'prefix'	: 'dbfield_',
	'fields'	: [],
	'Aaddendum'	: 'isAddendum',
	'Afieldtype'	: 'fieldType',
	'AgroupMand'	: 'groupMandatory',
	'Avalid'	: 'fieldIsValid',
	'Amanaged'	: 'fieldIsManaged',
	'Asubs'		: 'subFields'
};

FIELD.init = function( prefix, fields ) {
		var e;
		try {
			if (typeof prefix != 'undefined') FIELD.prop.prefix = prefix;
			FIELD.prop.fields = ( fields ) ? fields : ( FIELD.prop.fields[0] ? FIELD.prop.fields : IO.xpath("//*[starts-with(@id,'"+ FIELD.prop.prefix +"')]", document ) );
			FIELD.prop.doc = FIELD.prop.fields.length > 0 ? FIELD.prop.fields[0].ownerDocument : document;
			var re = new RegExp( '^' + FIELD.prop.prefix + '(.).*$');
			for ( var i = 0; i < FIELD.prop.fields.length; i++ ) {
				var f = FIELD.prop.fields[i];
				var fid = f.getAttribute('id');
				var fty = fid.replace( re, "$1");
				switch ( fty ) {
					case 'D' : FIELD.internal.initD( f, fid ); break;
					case 'U' : FIELD.internal.initU( f, fid ); break;
					case 'M' : FIELD.internal.initM( f, fid ); break;
					case 'Z' : FIELD.internal.initZ( f, fid ); break;
					case 'S' : FIELD.internal.initS( f, fid ); break;
					case 'L' : FIELD.internal.initS( f, fid ); break;
					case 'W' : FIELD.internal.initS( f, fid ); break;
					case 'F' : FIELD.internal.initS( f, fid ); break;
					case 'Y' : FIELD.internal.initY( f, fid ); break;
					case 'C' : FIELD.internal.initS( f, fid ); break;
					case 'h' : FIELD.internal.inith( f, fid ); break;
					default  : FIELD.internal.initField( f, fid, false );
				}
			}
		} catch(e) {
			IO.alert('FIELD.init', e );
		}
	};

FIELD.setFields = function( fs ) { FIELD.prop.fields = fs }

FIELD.internal.initField = function( f, fid, isManaged ) {
		if ( isManaged ) {
			f.setAttribute( FIELD.prop.Amanaged, true );
			f.setAttribute( FIELD.prop.Avalid, 'undefined' );
		}
		if ( f.hasAttribute( FIELD.prop.Aaddendum ) ) FIELD.internal.initAddendum( f );
		var subs = IO.xpath("//*[(starts-with(@id,'part.') and contains(@id,'."+fid+"')) or (@for='"+fid+"')]", document);
		if ( subs.length > 0 ) {
			for ( var i = 0; i < subs.length; i++ ) {
				if ( subs[i].hasAttribute('id') ) {
					subs[i] = subs[i].getAttribute('id');
				} else {
					var theId = ['undefined', i, fid].join('.');
					subs[i].setAttribute('id', theId );
					subs[i] = theId;
				}
			}
			f.setAttribute( FIELD.prop.Asubs, subs.join(',') );
		} else {
			IO.event.change( f );
		}
	};

FIELD.internal.setSignal = function( fieldid, status ) {
		var f;
		if (typeof fieldid == 'string') {
			f = FIELD.prop.doc.getElementById(fieldid);
		} else {
			f = fieldid;
			fieldid = f.hasAttribute('id') ? f.getAttribute('id') : '';
		}
		f.setAttribute( FIELD.prop.Avalid, status );
		var doc = f.ownerDocument;
		if ( f.hasAttribute( FIELD.prop.Asubs ) ) {
			var subids = f.getAttribute( FIELD.prop.Asubs ).split(',');
			for ( var i = 0; i < subids.length; i++ ) {
				doc.getElementById( subids[i] ).setAttribute( FIELD.prop.Avalid, status );
			}
		}
		var okt = doc.getElementById('ok.' + fieldid);
		var kot = doc.getElementById('ko.' + fieldid);
		if ( okt ) okt.setAttribute( 'collapsed', ( ! status) || (f.value == '') );
		if ( kot ) kot.setAttribute( 'collapsed', status );
	};

FIELD.validateTabbox = function( tbox ) {
		if (typeof tbox == 'undefined') tbox = IO.xpath("//xul:tabbox", document)[0];
		var curIndex = tbox.selectedIndex;
		var allPanels = XML.getElementChilds( XML.getFirstChildByName(tbox, 'tabpanels') );
		for ( var i = 0; i < allPanels.length; i++ ) {
			tbox.selectedIndex = i;
			if (! FIELD.validate( tbox.selectedPanel ) ) return false;
		}
		tbox.selectedIndex = curIndex;
		return true;
	};

FIELD.validateWizard = function( wiz ) {
		if (typeof wiz == 'undefined') wiz = IO.xpath("//xul:wizard", document)[0];
		var curIndex = wiz.pageIndex;
		var allPanels = wiz.wizardPages;
		for ( var i = 0; i < allPanels.length; i++ ) {
			wiz.pageIndex = i;
			if (! FIELD.validate( wiz.currentPage ) ) return false;
		}
		wiz.currentPage = curIndex;
		return true;
	};

FIELD.internal.getFieldsByParam = function( panelID ) {
		var e;
		try {
			if ( typeof panelID == 'undefined') return FIELD.prop.fields;
			var panel, tempid = false;
			if (typeof panelID == 'string') {
				panel = FIELD.prop.doc.getElementById( panelID );
			} else {
				panel = panelID;
				if ( ! panel.hasAttribute('id') ) {
					panel.setAttribute( 'id', 'validationTemporaryId' );
					tempid = true;
				}
				panelID = panel.getAttribute('id');
			}
			var fields = IO.xpath("//*[@id='"+panelID+"']//*[starts-with(@id,'"+ FIELD.prop.prefix+"')]", FIELD.prop.doc);
			if ( tempid ) panel.removeAttribute('id');
			return fields;
		} catch(e) {
			IO.alert('FIELD.internal.getFieldsByParam',e);
		}
	};

FIELD.validate = function( panelID ) {
		var fs = FIELD.internal.getFieldsByParam( panelID );
		var f, status = true;
		var groupm = new Object();
		for ( var i = 0; i < fs.length; i++ ) {
			f = fs[i];
			if (! f.disabled ) {
				if (FIELD.internal.validate( f ) ) {
					if ( f.hasAttribute( FIELD.prop.AgroupMand ) ) {
						var gm = f.getAttribute( FIELD.prop.AgroupMand );
						if ( groupm[gm] ) {
							groupm[gm].tvalue += f.value;
						} else {
							groupm[gm] = {'tvalue' : f.value, 'els' : new Array(), 'desc' : gm };
						}
						groupm[gm].els.push( f );
					}
				} else {
					if ( status ) {
						var e, doc = f.ownerDocument;
						try {
							if ( f.nodeName == 'textbox' ) {
								if ( ! f.collapsed ) {
									f.focus();
								} else if ( f.hasAttribute( FIELD.prop.Asubs ) ) {
									var subs = f.getAttribute( FIELD.prop.Asubs ).split(',');
									var sf = doc.getElementById(subs[0]);
									for ( var k = 0; (sf.nodeName == 'label') && (k < subs.length); k++ ) sf = doc.getElementById(subs[k]);
									if ( sf.nodeName != 'label' ) sf.focus();
								}
							}
						} catch(e) { };
					}
					status = false;
				}
			}
		}
		for ( var i in groupm ) {
			if ( groupm[i].tvalue == '' ) {
				for ( var j = 0; j < groupm[i].els.length; j++ ) FIELD.internal.setSignal( groupm[i].els[j], false );
				if (status) groupm[i].els[0].focus();
				status = false;
			}
		}
		return status;
	};

FIELD.reset = function( panelID ) {
		var e;
		try {
			var fields = FIELD.internal.getFieldsByParam( panelID );
			for ( var i = 0; i < fields.length; i++ ) {
				var f = fields[i];
				var doc = f.ownerDocument;
				var fieldid = f.getAttribute('id');
				f.removeAttribute( FIELD.prop.Avalid );
				if ( f.hasAttribute( FIELD.prop.Asubs ) ) {
					var subids = f.getAttribute( FIELD.prop.Asubs ).split(',');
					for ( var j = 0; j < subids.length; j++ ) doc.getElementById( subids[j] ).removeAttribute( FIELD.prop.Avalid );
				}
				var okt = doc.getElementById('ok.' + fieldid);
				var kot = doc.getElementById('ko.' + fieldid);
				if ( okt ) okt.setAttribute( 'collapsed', true );
				if ( kot ) kot.setAttribute( 'collapsed', true );
			}
		} catch(e) {
			IO.alert('FIELD.reset', e)
		}
	};

FIELD.internal.validate = function( f ) {
		var e;
		try {
			var status = f.hasAttribute( FIELD.prop.Amanaged ) ? f.getAttribute( FIELD.prop.Avalid ) != 'false' : true;
			if ( status && f.hasAttribute('class') ) {
				var fcl = f.getAttribute('class').replace(/\s+/g,' ').split(' ');
				if ( f.nodeName == 'menulist' ) f.setAttribute('value', f.selectedItem ? f.selectedItem.getAttribute('value') : '');
				for ( var j = 0; j < fcl.length; j++ ) {
					var c = fcl[j];
					switch (c) {
						case 'isMandatory'	: status = status && (f.value != ''); break;
						case 'isUppercase'	: f.value = f.value.toString().toUpperCase(); break;
					}
				}
			}
			FIELD.internal.setSignal( f.getAttribute('id'), status );
			return status;
		} catch(e) {
			IO.alert('FIELD.internal.validate', e)
		}
	};

FIELD.internal.initChange = function ( f, fid, func ) {
		var n = f.nodeName.toLowerCase();
		switch (n) {
			case 'menulist'	: f.addEventListener('ValueChange', func, false ); break;
			default		: f.addEventListener('change', func, false );
		}
	};

// FIELD.change = function( ev ) {
// 	var t;
// 	var f = ev.currentTarget;
// 	if ( f.hasAttribute( FIELD.prop.Afieldtype ) ) {
// 		t = f.getAttribute( FIELD.prop.Afieldtype );
// 	} else {
// 		var fid = f.getAttribute('id');
// 		var re = new RegExp( '^' + FIELD.prop.prefix + '(.).*$');
// 		var t = fid.replace( re, "$1" );
// 		if ( t.length != 1 ) return;
// 		if ( ( t == 'C') || ( t == 'W')) t = 'S';
// 		if ( t == 'h')  t = 'U';
// 	}
// 	var fname = 'change' + t;
// 	if ( FIELD[fname] ) FIELD[fname]( ev );
// 	if (f.hasAttribute("isAddendum")) FIELD.sum ( { 'currentTarget' : f });
// }

FIELD.set = function( f, v ) {
		FIELD.rawset( f, v );
		IO.event.change( f );
	};

FIELD.rawset = function( f, v ) {
		f.value = v;
		switch ( f.nodeName ) {
			case 'checkbox'	: 
					  f.checked = isNaN( parseFloat( v )) ? ( v.length > 0 ) : parseFloat( v ) != 0;
					  break;
			case 'menulist'	: break;
			default		: f.setAttribute('value', v );
		}
	};

FIELD.get = function( f ) {
		switch ( f.nodeName ) {
			case 'checkbox'	: v = f.checked ?  f.value : ''; break;
			case 'menulist'	: v = f.value; break;
			default			: v = f.value;
		}
		if ( typeof v == 'undefined') v = f.hasAttribute('value') ?  f.getAttribute('value') : '';
		return v;
	};

FIELD.clear = function( f ) {
		if ( f ) {
			FIELD.set( f, '');
			f.value = ''; // doubled because of formatting in case of money
		}
	};

FIELD.internal.initD = function( f, fid, fv ) {
		var e;
		try {
			if ( ! (f.hasAttribute(FIELD.prop.Amanaged) && (f.getAttribute(FIELD.prop.Amanaged)=='true') ) ) {
				if (typeof fid == 'undefined' ) fid = f.getAttribute('id');
				if (typeof fv == 'undefined' ) fv = f.value ? f.value : f.getAttribute('value');
				var doc = f.ownerDocument;
				var d = doc.getElementById( 'part.1.' + fid );
				if (! (d)) return;
				var m = doc.getElementById( 'part.2.' + fid );
				if (! (m)) return;
				var y = doc.getElementById( 'part.3.' + fid );
				if (! (y)) return;
				d.addEventListener( 'change', FIELD.changeD, false);
				m.addEventListener( 'change', FIELD.changeD, false);
				y.addEventListener( 'change', FIELD.changeD, false);
				f.addEventListener( 'change', FIELD.changeDmain, false );
				FIELD.internal.initField( f, fid, true );
				IO.event.change( f );
			}
		} catch(e) {
			IO.alert('FIELD.internal.initD', e );
		}
	};

FIELD.changeDmain = function( ev ) {
		var f = ev.currentTarget;
		var fid = f.getAttribute('id');
		var doc = f.ownerDocument;
		var d = doc.getElementById( 'part.1.' + fid );
		if (! (d)) return;
		var m = doc.getElementById( 'part.2.' + fid );
		if (! (m)) return;
		var y = doc.getElementById( 'part.3.' + fid );
		if (! (y)) return;
		var dp = f.value != '' ? FIELD.internal.date.sql2dmy( f.value ) : ['','',''];
		d.value = dp[0];
		m.value = dp[1];
		y.value = dp[2];
		IO.event.change( y );
	};

FIELD.changeD = function( ev ) {
		var e;
		try {
			var cf = ev.currentTarget;
			var ps = cf.getAttribute('id').split('.');
			var pref = ps[0];
			var curp = ps[1];
			var tgtid = ps[2];
			var doc = cf.ownerDocument;
			var day   = doc.getElementById([pref, 1, tgtid].join('.'));
			var month = doc.getElementById([pref, 2, tgtid].join('.'));
			var year  = doc.getElementById([pref, 3, tgtid].join('.'));
			var oggi = new Date();
			day.value   = day.value.toString().replace(/[^0-9]/g,'');
			month.value = month.value.toString().replace(/[^0-9]/g,'');
			year.value  = year.value.toString().replace(/[^0-9]/g,'');
			if ( ( parseInt(curp) != 3 ) && ( year.value == '')) {
				year.value = oggi.getFullYear();
			} else if ( ( year.value != '') && (parseInt( year.value ) < 100 ) ) {
				year.value = parseInt( year.value ) + ( parseInt( year.value ) < 40 ? 2000 : 1900 );
			}
			var status, r = '';
			if ( ( day.value != '' ) && ( month.value != '' ) && ( year.value.length == 4 ) ) {
				var isValid = FIELD.internal.date.valid( day.value, month.value, year.value );
				if (isValid) {
					r =  FIELD.internal.date.js2sql( isValid );
					var dp = r.split('-');
					day.value   = dp[2];
					month.value = dp[1];
					year.value  = dp[0];
					var f = doc.getElementById(tgtid);
					oggi = new Date( oggi.getFullYear(), oggi.getMonth(), oggi.getDate(), 12, 0 );
					if ( f.className.match(/\bnoPast\b/) ) {
						if ( oggi > isValid ) r = '';
					}
					if ( f.className.match(/\bnoFuture\b/) ) {
						oggi = new Date( oggi.getFullYear(), oggi.getMonth(), oggi.getDate(), 12, 0 );
						if ( oggi < isValid ) r = '';
					}
					if ( ( r != '' ) && ( f.hasAttribute('greaterThan') )) {
						var f0 = doc.getElementById( f.getAttribute('greaterThan') );
						if ( (f0 ) && ( f0.value ) ) {
							var d0 = FIELD.internal.date.sql2js( f0.value );
							if ( (! (d0)) || ( isValid < d0 ) ) r = '';
						}
					}
				}
				status = r != '';
			} else if  ( ( day.value != '' ) || ( month.value != '' ) || ( year.value.length == 4 ) ) {
				status = false;
			} else {
				status = true;
			}
			FIELD.rawset( doc.getElementById( tgtid ), r );
			FIELD.internal.setSignal( tgtid, status );
			if ( status ) FIELD.internal.validate( doc.getElementById( tgtid ) );
		} catch(e) {
			IO.alert( 'FIELD.changeD ' + ev.currentTarget.getAttribute("id"), e );
		}
	};

FIELD.internal.initU = function( f, fid ) {
		var nn = f.nodeName;
		if ( ! (f.hasAttribute(FIELD.prop.Amanaged) && (f.getAttribute(FIELD.prop.Amanaged)=='true') ) ) {
			switch (nn) {
				case 'textbox'	:	f.addEventListener('input', FIELD.inputU, false );
							f.addEventListener( 'change', FIELD.changeU, false);
							f.style.textAlign = 'right';
							break;
				case 'menulist'	:	f.addEventListener( 'ValueChange', FIELD.changeU, false);
							break;
			}
			if ( f.hasAttribute('maxValueFrom') ) {
				var mve = f.ownerDocument.getElementById( f.getAttribute('maxValueFrom') );
				mve.value = (mve.value) ? mve.value : mve.getAttribute('value');
			}
			FIELD.internal.initField( f, fid, true );
		}
	};

FIELD.inputU = function(ev) {
		var f = ev.currentTarget;
		var v = f.value.toString();
		var v1 = v.replace(/[^0-9]/g,'');
		if ( v1 != v ) f.value = v1;
	};

FIELD.changeU = function( ev ) {
		var e;
		try {
			var f = ev.currentTarget;
			var doc = f.ownerDocument;
			var status = true;
			var v = isNaN( parseInt(f.value) ) ? 0 : parseInt(f.value);
			if ( f.hasAttribute('maxValue') ) {
				var m = parseInt( f.getAttribute('maxValue') );
				if ( v > m ) v = m;
			}
			if ( f.hasAttribute('maxValueFrom') ) {
				var m = parseInt( doc.getElementById( f.getAttribute('maxValueFrom') ).value );
				if ( isNaN(m) ) m = 0;
				if ( v > m ) v = m;
			}
			if ( f.hasAttribute('greaterThan') ) {
				var f0 = doc.getElementById( f.getAttribute('greaterThan') );
				if ( (f0 ) && ( f0.value ) && (! isNaN( parseInt(f0.value)) ) && ( v < parseInt(f0.value) ) ) status = false;
			}
			if ( f.hasAttribute('smallerThan') ) {
				var f0 = doc.getElementById( f.getAttribute('smallerThan') );
				if ( (f0 ) && ( f0.value ) && (! isNaN( parseInt(f0.value)) ) && ( v > parseInt(f0.value) ) ) status = false;
			}
			v = v == 0 ? '' : v.toString();
			f.value = v;
			FIELD.internal.setSignal( f.getAttribute('id'), status );
			if ( status ) FIELD.internal.validate( f );
		} catch(e) {
			IO.alert( 'FIELD.changeU', e );
		}
	};

FIELD.internal.initM = function( f, fid ) {
		if ( ! (f.hasAttribute(FIELD.prop.Amanaged) && (f.getAttribute(FIELD.prop.Amanaged)=='true') ) ) {
			f.addEventListener('input', FIELD.inputM, false );
			f.addEventListener( 'change', FIELD.changeM, false);
			f.style.textAlign = 'right';
			FIELD.internal.initField( f, fid, true );
		}
	};

FIELD.inputM = function(ev) {
		var f = ev.currentTarget;
		var v = f.value.toString();
		var v1 = v.replace(/[,.]+/g,'.').replace(/[^0-9.]/g,'');
		if ( v1 != v ) f.value = v1;
	};

FIELD.changeM = function( ev ) {
		var e;
		try {
			var f = ev.currentTarget;
			var doc = f.ownerDocument;
			var v = f.value;
			while ( v.match( /\..*\./) ) { v = v.replace( /\./,'') }
			v = isNaN( parseFloat(v) ) ? 0 : parseFloat(v);
			var status = true;
			if ( f.hasAttribute('maxValue') ) {
				var m = parseFloat( f.getAttribute('maxValue') );
				if ( v > m ) v = m;
			}
			if ( f.hasAttribute('maxValueFrom') ) {
				var m = parseFloat( doc.getElementById( f.getAttribute('maxValueFrom') ).value );
				if ( isNaN(m) ) m = 0;
				if ( m == 0 ) {
					f.setAttribute('readonly', true );
					f.setAttribute('tabindex', -1 );
				} else {
					if ( v > m ) v = m;
				}
			}
			if ( f.hasAttribute('greaterThan') ) {
				var f0 = doc.getElementById( f.getAttribute('greaterThan') );
				if ( (f0 ) && ( f0.value ) && (! isNaN( parseFloat(f0.value)) ) && ( v < parseFloat(f0.value) ) ) status = false;
			}
			if ( f.hasAttribute('smallerThan') ) {
				var f0 = doc.getElementById( f.getAttribute('smallerThan') );
				if ( (f0 ) && ( f0.value ) && (! isNaN( parseFloat(f0.value)) ) && ( v > parseFloat(f0.value) ) ) status = false;
			}
			v = v.toFixed(2).toString();
			//f.value = v == '0.00' ? '' : v;
			f.value = v;
			FIELD.internal.setSignal( f.getAttribute('id'), status );
			if ( status ) FIELD.internal.validate( f );
		} catch(e) {
			IO.alert( 'FIELD.changeM', e );
		}
	};

FIELD.internal.initZ = function( f, fid ) {
		var nn = f.nodeName;
		if ( ! (f.hasAttribute(FIELD.prop.Amanaged) && (f.getAttribute(FIELD.prop.Amanaged)=='true') ) ) {
			switch (nn) {
				case 'textbox'	:	f.addEventListener('input', FIELD.inputZ, false );
							f.addEventListener( 'change', FIELD.changeZ, false);
							f.style.textAlign = 'right';
							break;
				case 'menulist'	:	f.addEventListener( 'ValueChange', FIELD.changeZ, false);
							break;
			}
			FIELD.internal.initField( f, fid, true );
		}
	};

FIELD.inputZ = function(ev) {
		var f = ev.currentTarget;
		var v = f.value.toString();
		var v1 = v.replace(/[^0-9]/g,'');
		if ( v1 != v ) f.value = v1;
	};

FIELD.changeZ = function( ev ) {
		var e;
		try {
			var f = ev.currentTarget;
			var status = ( f.value == '' ) || f.value.match(/^[0-9]{5}$/);
			FIELD.internal.setSignal( f.getAttribute('id'), status );
			if ( status ) FIELD.internal.validate( f );
		} catch(e) {
			IO.alert( 'FIELD.changeZ', e );
		}
	};

FIELD.internal.initS = function( f, fid ) {
		if ( ! (f.hasAttribute(FIELD.prop.Amanaged) && (f.getAttribute(FIELD.prop.Amanaged)=='true') ) ) {
			if ( f.nodeName == 'menulist' ) f.addEventListener( 'ValueChange', FIELD.changeS, false );
			else f.addEventListener( 'change', FIELD.changeS, false );
			FIELD.internal.initField( f, fid, true );
		}
	};

FIELD.changeS = function( ev ) {
		var e;
		try {
			var f = ev.currentTarget;
			if ( f.nodeName == 'menulist' ) f.setAttribute('value', f.selectedItem ? f.selectedItem.getAttribute('value') : '');
			if ( f.value ) f.value = f.value.replace(/^\s+/,'').replace(/\s+$/,'');
			FIELD.internal.setSignal( f.getAttribute('id'), true );
			FIELD.internal.validate( f );
		} catch(e) {
			IO.alert( 'FIELD.changeS', e + "\r\n" + f.getAttribute('id') );
		}
	};

FIELD.internal.initY = function( f, fid ) {
		if ( ! (f.hasAttribute(FIELD.prop.Amanaged) && (f.getAttribute(FIELD.prop.Amanaged)=='true') ) ) {
			f.addEventListener('input', FIELD.changeY, false );
			f.addEventListener( 'change', FIELD.changeY, false);
			FIELD.internal.initField( f, fid, true );
		}
	};

FIELD.changeY = function( ev ) {
		var e;
		try {
			var f = ev.currentTarget;
			var v = f.value.toUpperCase().replace(/\s+/,'');
			var status = !! f.value.match(/^([A-Z]{6}[0-9]{2}[A-Z][0-9]{2}[A-Z][0-9]{3}[A-Z])?$/);
			if (v != f.value) f.value = v;
			FIELD.internal.setSignal( f.getAttribute('id'), status );
			if (status) FIELD.internal.validate( f );
		} catch(e) {
			IO.alert( 'FIELD.changeS', e );
		}
	};

FIELD.internal.inith = function( f, fid ) {
		var nn = f.nodeName;
		if ( ! (f.hasAttribute(FIELD.prop.Amanaged) && (f.getAttribute(FIELD.prop.Amanaged)=='true') ) ) {
			var ht = f.hasAttribute( FIELD.prop.Afieldtype ) ? f.getAttribute( FIELD.prop.Afieldtype ) : 'U';
			switch (nn) {
				case 'textbox'	:	if ( FIELD.internal['init'+ht] ) FIELD.internal['init'+ht]( f, fid ); break;
				case 'menulist'	:	f.addEventListener( 'ValueChange', FIELD.changeh, false);
							break;
			}
			FIELD.internal.initField( f, fid, true );
		}
	};

FIELD.changeh = function( ev ) {
		var e;
		try {
			var f = ev.currentTarget;
			if ( f.nodeName == 'textbox' ) {
				FIELD.changeU( ev );
				return;
			}
			FIELD.internal.setSignal( f.getAttribute('id'), true );
			FIELD.internal.validate( f );
		} catch(e) {
			IO.alert( 'FIELD.changeU', e );
		}
	};

FIELD.internal.initAddendum = function( f ) {
		f.addEventListener( 'change', FIELD.sum, false );
	};

FIELD.internal.getAddenda = function() {
		var pa = IO.xpath("//*[@"+FIELD.prop.Aaddendum+"]", FIELD.prop.doc);
		var ea = new Array, ta = new Object();
		for ( var i = 0; i < pa.length; i++ ) ta[ pa[i].getAttribute( FIELD.prop.Aaddendum ) ] = pa[i].getAttribute( 'id' );
		for ( var i in ta ) {
			var f = FIELD.prop.doc.getElementById( ta[i] );
			if (f) {
				ea.push( f );
			} else {
				alert( 'non trovo ' + i );
			}
		}
		return ea;
	};

FIELD.sum = function( ev ) {
		var e;
		try {
			var fs;
			if ( typeof ev == 'undefined') {
				fs = FIELD.internal.getAddenda();
			} else {
				fs = [ ev.currentTarget ];
			}
			for ( var j = 0; j < fs.length; j++ ) {
				var f = fs[j];
				var tgtid = f.getAttribute( FIELD.prop.Aaddendum );
				var adds = IO.xpath("//*[@"+FIELD.prop.Aaddendum+" = '"+tgtid+"']", document);
				var tot = 0;
				for ( var i = 0; i < adds.length; i++ ) {
					var v = adds[i].value;
					v = isNaN( parseFloat( v ) ) ? 0 : parseFloat(v);
					tot += v;
				}
				var tgt = f.ownerDocument.getElementById( tgtid );
				tgt.value = tot;
				//FIELD.change({ 'currentTarget' : tgt }); // qqq
				IO.event.change( tgt );
			}
		} catch(e) {
			IO.alert( 'FIELD.sum', e );
		}
	};

/* TYPE-RELATED METHODS */

FIELD.internal.date = {};

FIELD.internal.date.sql2dmy = function( v ) {
		if ( v == '0000-00-00') return false;
		var re = new RegExp('^([0-9]{4})\-([0-9]{2})\-([0-9]{2})$');
		return re.test(v) ? [ v.replace( re, "$3" ), v.replace( re, "$2" ), v.replace( re, "$1" ) ] : false;
	};

FIELD.internal.date.sql2js = function( v ) {
		var parts = FIELD.internal.date.sql2dmy( v );
		return (parts) ? FIELD.internal.date.valid( parts[0], parts[1], parts[2] ) : false;
	};

FIELD.internal.date.valid = function( d, m, y) {
		var e;
		try {
			if ( typeof d == 'string') d = parseInt( d.replace(/^0*/,'') );
			if ( typeof m == 'string') m = parseInt( m.replace(/^0*/,'') );
			if ( typeof y == 'string') y = parseInt( y.replace(/^0*/,'') );
			var dt = new Date( y, m -1, d, 12, 0 );
			return dt;
		} catch(e) {
			return false;
		}
	};

FIELD.internal.date.js2sql = function( d ) {
		var yn = d.getFullYear();
		var mn = d.getMonth() + 1;
		var dn = d.getDate();
		if ( mn < 10 ) mn = '0' + mn;
		if ( dn < 10 ) dn = '0' + dn;
		return yn + '-' + mn + '-' + dn;
	};
