/*
	IO tools jslibrary for use in XUL environment
	best viewed with 8 spaces per tab, charset UTF-8
	copyright © 2006 by Marco Balestra <balestra@cesmail.net>
	requires: xmlLib.js - by the same author
*/

netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect UniversalBrowserAccess");

var IO = {'internal': {} };

IO.prop = {
		'defaultpath'	:	'~/',
		'defaultxslpath':	'chrome://main/content/xsl/',
		
		'consoleCID'	:	'@mozilla.org/consoleservice;1',
		'consoleIID'	:	Components.interfaces.nsIConsoleService,
		'localfileCID'	:	'@mozilla.org/file/local;1',
		'localfileIID'	:	Components.interfaces.nsILocalFile,
		'finstreamCID'	:	'@mozilla.org/network/file-input-stream;1',
		'finstreamIID'	:	Components.interfaces.nsIFileInputStream,
		'foutstreamCID'	:	'@mozilla.org/network/file-output-stream;1',
		'foutstreamIID'	:	Components.interfaces.nsIFileOutputStream,
		'sinstreamCID'	:	'@mozilla.org/scriptableinputstream;1',
		'sinstreamIID'	:	Components.interfaces.nsIScriptableInputStream,
		'suniconvCID'	:	'@mozilla.org/intl/scriptableunicodeconverter',
		'suniconvIID'	:	Components.interfaces.nsIScriptableUnicodeConverter,
		'x509certdbCID'	:	'@mozilla.org/security/x509certdb;1',
		'x509certdbIID'	:	Components.interfaces.nsIX509CertDB,
		
		'convinstreamCID'	:	'@mozilla.org/intl/converter-input-stream;1',
		'convinstreamIID'	:	Components.interfaces.nsIConverterInputStream,
		'convoutstreamCID'	:	'@mozilla.org/intl/converter-output-stream;1',
		'convoutstreamIID'	:	Components.interfaces.nsIConverterOutputStream,
		
		'sep'		:	navigator.platform.toLowerCase().indexOf('win') > -1 ? '\\' : '/',
		'dirservCID'	:	'@mozilla.org/file/directory_service;1',
		'propsIID'	:	Components.interfaces.nsIProperties,
		'filespecCID'	:	'@mozilla.org/filespec;1',
		'filespecIID'	:	Components.interfaces.nsIFileSpec,
		'fileIID'	:	Components.interfaces.nsIFile,
		
		'defined'	:	true
	};

IO.cache = {
		'xsls'		:	{},
		'defined'	:	true
	};

IO.dump = function (str) {
// 		var con = IO.internal.instance('console');
// 		con.logStringMessage(str);
		Components.classes['@mozilla.org/consoleservice;1']
			.getService(Components.interfaces.nsIConsoleService)
			.logStringMessage(str);
	};

IO.importCACert = function( _path, _basePath ) {
		var e;
		try {
			if (typeof _basePath == 'undefined') _basePath = IO.getUserChrome().path + IO.prop.sep;
			var file = IO.internal.instance('localfile');
			file.initWithPath( _basePath + _path );
			if ( ! file.exists() ) throw( 'CACert file not found: ' + _basePath + _path );
			var myserv = IO.internal.instance('x509certdb');
			myserv.importCertsFromFile(null, file, Components.interfaces.nsIX509Cert.CA_CERT);
		} catch(e) {
			IO.dump( 'IO.importCACert: ' + e );
			//throw(e);
		}
	};

/* Only available for stand-alone deployment with bundled binary */
IO.getStandaloneDir = function() {
		var e;
		if (typeof IO.cache.standalonedir != 'undefined') return IO.cache.standalonedir;
		try {
			IO.cache.standalonedir = Components.classes[IO.prop.dirservCID].getService(IO.prop.propsIID).get("CurProcD", IO.prop.fileIID).parent.parent;
			if ( IO.cache.standalonedir.leafName == 'XUL.framework') IO.cache.standalonedir = IO.cache.standalonedir.parent.parent.parent.parent; /* Mac OS X */
		} catch(e) {
			IO.dump('IO.getStandaloneDir: ' + e );
			throw( e );
		}
		return IO.cache.standalonedir;
	};

/* Only available for stand-alone deployment with bundled binary */
IO.getChromesDir = function() {
		var e;
		if (typeof IO.cache.chromesdir != 'undefined') return IO.cache.chromesdir;
		try {
			IO.cache.chromesdir = Components.classes[IO.prop.dirservCID].getService(IO.prop.propsIID).get("CurProcD", IO.prop.fileIID).parent;
			if ( IO.cache.chromesdir.leafName == 'Versions') { /* Mac OS X */
				IO.cache.chromesdir = IO.cache.chromesdir.parent.parent.parent;
				IO.cache.chromesdir.append('Resources');
			}
			IO.cache.chromesdir.append('chrome');
		} catch(e) {
			IO.dump('IO.getChromesDir: ' + e );
			throw( e );
		}
		return IO.cache.chromesdir;
	};

IO.internal.string2xml = function( _s ) {
		var d, e, doc;
		d = new DOMParser();
		try {
			doc = d.parseFromString(_s, "application/xml");
		} catch (e) {
			IO.dump('IO.internal.string2xml: ' + e );
			throw( e );
		}
		return doc;
	};

IO.internal.xml2string = function( d ) {
		if (typeof IO.cache.xmlserializer == 'undefined') IO.cache.xmlserializer = new XMLSerializer();
		return IO.cache.xmlserializer.serializeToString( d );
	};

IO.internal.instance = function(c) { return Components.classes[ IO.prop[ c + 'CID'] ].createInstance( IO.prop[ c + 'IID' ] ) };

IO.getDefaultPath = function() { return IO.prop.defaultpath }

IO.setDefaultPath = function(p) { if (typeof p == 'string') IO.prop.defaultpath = p }

IO.getDefaultXslPath = function() { return IO.prop.defaultxslpath }

IO.setDefaultXslPath = function(p) { if (typeof p == 'string') IO.prop.defaultxslpath = p }

IO.getPrefBranch = function() { return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch) }

IO.getUserChrome = function() {
		if (typeof IO.cache.userChrome == 'undefined') IO.cache.userChrome = Components.classes[IO.prop.dirservCID].getService(IO.prop.propsIID).get("UChrm", IO.prop.fileIID);
		return IO.cache.userChrome;
	};

IO.getPrefType = function( key ) {
		var e, prefs = IO.getPrefBranch();
		try {
			return prefs.getPrefType( key );
		} catch(e) {
			return prefs.PREF_INVALID;
		}
	};

IO.getPref = function( key ) {
		var e;
		try {
			var prefs = IO.getPrefBranch();
			var type = IO.getPrefType( key );
			switch ( type ) {
				case prefs.PREF_INVALID	: return undefined;
				case prefs.PREF_STRING	: return prefs.getCharPref( key );
				case prefs.PREF_INT	: return prefs.getIntPref( key );
				case prefs.PREF_BOOL	: return prefs.getBoolPref( key );
			}
		} catch(e) {
			IO.dump( 'IO.getPref: ' + e );
			throw(e);
		}
	};

IO.setPref = function( key, val ) {
		var e;
		try {
			var prefs = IO.getPrefBranch();
			var type = IO.getPrefType( key );
			if ( type == prefs.PREF_INVALID ) {
				type = typeof val;
				switch (type) {
					case 'number'	: type = prefs.PREF_INT; break;
					case 'boolean'	: type = prefs.PREF_BOOL; break;
					default		: type = prefs.PREF_STRING;
				}
			}
			switch ( type ) {
				case prefs.PREF_STRING	: prefs.setCharPref( key, String( val) ); break;
				case prefs.PREF_INT	: prefs.setIntPref( key, parseInt( val ) ); break;
				case prefs.PREF_BOOL	: prefs.setBoolPref( key, !!(val) );
			}
		} catch(e) {
			IO.dump( 'IO.setPref: ' + e );
			throw(e);
		}
	};

IO.getPrefs = function( keylist ) {
		var e;
		try {
			var ans = new Array();
			for ( var i = 0; i < keylist.length; i++ ) ans[i] = IO.getPref( keylist[i] );
			return ans;
		} catch(e) {
			IO.dump( 'IO.getPrefs: ' + e );
			throw(e);
		}
	};

IO.delPref = function( keybranch ) {
		var e;
		try {
			IO.getPrefBranch().deleteBranch( keybranch );
		} catch(e) {
			IO.dump( 'IO.delPref: ' + e );
			throw(e);
		}
	};

IO.fixPref = function( key, val ) {
		var e;
		try {
			var prefs = IO.getPrefBranch();
			var type = IO.getPrefType( key );
			var typeIn = typeof val;
			switch ( typeIn ) {
				case 'number'	: type = ( type == prefs.PREF_INT    ) ? type : prefs.PREF_INVALID; break;
				case 'boolean'	: type = ( type == prefs.PREF_BOOL   ) ? type : prefs.PREF_INVALID; break;
				default		: type = ( type == prefs.PREF_STRING ) ? type : prefs.PREF_INVALID;
			}
			if ( type == prefs.PREF_INVALID ) {
				switch ( typeIn ) {
					case 'number'	: prefs.setIntPref( key, val ); break;
					case 'boolean'	: prefs.setBoolPref( key, val ); break;
					default		: prefs.setCharPref( key, String( val) );
				}
			}
		} catch(e) {
			IO.dump( 'IO.fixPref: ' + e );
			throw(e);
		}
	};

IO.openURI = function( u ) {
		// open URI "u" in the default browser
		var e;
		try {
			// first construct an nsIURI object using the ioservice
			var ioservice = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
			var uriToOpen = ioservice.newURI( u , null, null);
			var extps = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService);
			// now, open it!
			extps.loadURI( uriToOpen, null);
		} catch(e) {
			IO.dump( 'IO.openURI: ' + e );
			throw(e);
		}
	};

IO.read = function( _path, _basePath, _charset ) {
		var e;
		try {
			if (typeof _charset != 'string') _charset = "UTF-8";
			if (typeof _basePath != 'string') _basePath = IO.getDefaultPath();
			var file = IO.internal.instance('localfile');
			file.initWithPath( _basePath + _path );
			if ( ! file.exists() ) throw( 'File not found: ' + _basePath + _path );
			var fis = IO.internal.instance('finstream');
			var cis = IO.internal.instance('convinstream');
			fis.init( file, 0x01, 0666, 0);
			cis.init( fis, _charset, 4096, cis.DEFAULT_REPLACEMENT_CHARACTER);
			var txt = new Array();
			var tmpContent = {};
			while ( cis.readString(-1, tmpContent) ) { txt.push(tmpContent.value) }
			cis.close();
			fis.close();
			return txt.join("");
		} catch(e) {
			IO.dump( 'IO.read: ' + e );
			throw(e);
		}
	};

IO.rm = function( _path, _basePath, _silent ) {
		var e;
		try {
			if (typeof _basePath != 'string') _basePath = IO.getDefaultPath();
			if (typeof _silent == 'undefined') _silent = false;
			var file = IO.internal.instance('localfile');
			file.initWithPath( _basePath + _path );
			if ( file.exists() ) {
				file.remove( false );
			} else if (! _silent ) {
				throw( 'File not found: ' + _basePath + _path );
			}
		} catch(e) {
			IO.dump( 'IO.rm: ' + e );
			throw(e);
		}
	};

IO.rmdir = function( _path, _basePath, _recurse, _silent ) {
		var e;
		try {
			if (typeof _basePath != 'string') _basePath = IO.getDefaultPath();
			if (typeof _recurse  == 'undefined') _recurse = false;
			if (typeof _silent   == 'undefined') _silent  = false;
			var file = IO.internal.instance('localfile');
			file.initWithPath( _basePath + _path );
			if ( file.exists() && file.isDirectory() ) {
				file.remove( _recurse );
			} else if (! _silent ) {
				if (! file.exists() ) throw( 'Directory not found: ' + _basePath + _path );
				if (! file.isDirectory() ) throw( 'Not a directory: ' + _basePath + _path );
			}
		} catch(e) {
			IO.dump( 'IO.rmdir: ' + e );
			throw(e);
		}
	};

IO.exists = function( _path, _basePath ) {
		var e;
		try {
			if (typeof _basePath != 'string') _basePath = IO.getDefaultPath();
			var file = IO.internal.instance('localfile');
			file.initWithPath( _basePath + _path );
			return file.exists();
		} catch(e) {
			IO.dump( 'IO.exists: ' + e );
			throw(e);
		}
	};

IO.modTime = function( _path, _basePath ) {
		var e;
		try {
			if (typeof _basePath != 'string') _basePath = IO.getDefaultPath();
			var file = IO.internal.instance('localfile');
			file.initWithPath( _basePath + _path );
			return file.lastModifiedTime;
		} catch(e) {
			IO.dump( 'IO.exists: ' + e );
			throw(e);
		}
	};

IO.curl = function( uri, destfolder, destname) {
		var e;
		try {
			var curl = IO.internal.instance('filespec');
			curl.nativePath = '/usr/bin/curl';
			if (typeof destname == 'undefined') destname = uri.toString().replace(/^.*\/([^/]+)$/,"$1");
			if (typeof destfolder != 'string') destfolder = destfolder.path.toString();
			if (! destfolder.match(/\/$/) ) destfolder += '/';
			curl.execute( uri + " --output '" + destfolder + destname + "'" );
		} catch(e) {
			IO.dump(e);
			throw(e);
		}
	};

IO.readRaw = function( file ) {
		try {
			var data = new String();
			var fiStream = IO.internal.instance('finstream');
			var siStream = IO.internal.instance('sinstream');
			fiStream.init(file, 1, 0, false);
			siStream.init(fiStream);
			data += siStream.read(-1);
			siStream.close();
			fiStream.close();
			return data;
		} 
		catch(e) {
			return false;
		}
	};

IO.write = function(_path, _txt, _basePath, _charset) {
		var e, file, writer, converter;
		if (typeof _charset != 'string') _charset = "utf-8";
		if (typeof _basePath != 'string') _basePath = IO.getDefaultPath();
		if ( ! _basePath.match(/[\\\/]$/) ) _basePath += IO.prop.sep;
		if (typeof _txt == 'object') try {
			_txt = IO.internal.xml2string( _txt );
		} catch (e) {
			IO.dump( 'IO.write (1): ' + e );
			throw(e);
		}
		if (typeof _txt != 'string') return false;
		try {
			file = IO.internal.instance('localfile');
			if ( _basePath != '') {
				file.initWithPath(_basePath);
				if ( file.exists() && !file.isDirectory() ) return false;
			}
			file.initWithPath(_basePath+_path);
			if ( file.exists() ) file.remove(false);
			file.create(file.NORMAL_FILE_TYPE, 0600)
			writer = IO.internal.instance('foutstream');
			writer.init(file, 0x02 | 0x08 | 0x20, 0664, 0);
			converter = IO.internal.instance('convoutstream');
			converter.init(writer, _charset, 0, ' ');
			converter.writeString(_txt);
			converter.close();
			return true;
		} catch (e) {
			IO.dump( 'IO.write (2): ' + e );
			throw(e);
		}
	};

IO.mkdir = function(_path) {
		var e;
		if (typeof _path != 'string') return false;
		try {
			var file = IO.internal.instance('localfile');
			file.initWithPath(_path);
			if ( file.exists() && file.isDirectory() ) return true;
			file.create(file.DIRECTORY_TYPE, 0777);
			return true;
		} catch (e) {
			IO.dump( 'IO.mkdir: ' + e );
			throw(e);
		}
	};

IO.ls = function( p, _basePath ) {
		var e;
		try {
			if (typeof _basePath != 'string') _basePath = IO.getDefaultPath();
			file = IO.internal.instance('localfile');
			file.initWithPath(_basePath + p);
			if ( ! file.isDirectory() ) return false;
			/* file is the given directory (nsIFile) */
			var entries = file.directoryEntries;
			var array = [];
			while( entries.hasMoreElements() ) {
				var entry = entries.getNext();
				entry.QueryInterface(IO.prop.fileIID);
				array.push(entry);
			}
			return array;
		} catch(e) {
			IO.dump( 'IO.lsFile: ' + e );
			throw(e);
		}
	};

IO.lsPath = function( p, bp ) {
		var e;
		try {
			var a = IO.ls( p, bp );
			for (var i=0; i < a.length; i++) a[i] = a[i].path;
			return a;
		} catch(e) {
			IO.dump( 'IO.lsPath: ' + e );
			throw(e);
		}
	};

IO.lsName = function( p, bp ) {
		var e;
		try {
			var a = IO.ls( p, bp );
			for (var i=0; i < a.length; i++) a[i] = a[i].leafName;
			return a;
		} catch(e) {
			IO.dump( 'IO.lsName: ' + e );
			throw(e);
		}
	};

IO.readXML = function(_path, _basePath, _charset) {
		if (typeof _charset != 'string') _charset = "utf-8";
		return IO.internal.string2xml( IO.read( _path, _basePath, _charset ) );
	};

IO.newXML = function( rootNodeName, charset) {
		if (typeof rootNodeName != 'string') rootNodeName = "root";
		return document.implementation.createDocument('',rootNodeName,null);
	};

IO.internal.localxsl = function(x) {
		var e;
		try {
			if (typeof IO.cache.xsls[x] == 'undefined') IO.cache.xsls[x] = XML.load( x.indexOf('/') < 0 ? IO.prop.defaultxslpath + x : x);
			return IO.cache.xsls[x];
		} catch(e) {
			IO.dump( 'IO.internal.localxsl: ' + e );
			throw(e);
		}
	};

IO.internal.xsltprocessor = function() {
		if (typeof IO.cache.xsltprocessor == 'undefined') {
			IO.cache.xsltprocessor = new XSLTProcessor();
		} else {
			IO.cache.xsltprocessor.reset();
		}
		return IO.cache.xsltprocessor;
	};

IO.xform = function( xml, xsl, params ) {
		var e, proc = IO.internal.xsltprocessor();
		try {
			proc.importStylesheet( typeof xsl == 'string' ? IO.internal.localxsl(xsl) : xsl );
			if (params) for (var i in params) proc.setParameter( null, i, params[i] );
			return proc.transformToDocument( xml );
		} catch (e) {
			IO.dump( 'IO.xform error: ' + e );
			throw( e );
		}
	};

IO.xforminto = function( xml, xsl, params, doc ) {
		var e, proc = IO.internal.xsltprocessor();
		if (typeof doc == 'undefined' ) doc = document;
		try {
			proc.importStylesheet( typeof xsl == 'string' ? IO.internal.localxsl(xsl) : xsl );
			if (params) for (var i in params) proc.setParameter( null, i, params[i] );
			return proc.transformToFragment( xml, doc );
		} catch (e) {
			alert( 'IO.xforminto error: ' + e );
		}
	};

IO.xformin = function( xml, xsl, params, node ) {
		var e;
		try {
			var doc = node.ownerDocument;
			var o = IO.xforminto(xml, xsl, params, doc);
			var ns = o.firstChild;
			XML.zapAllChilds( node );
			while( ns.firstChild ) node.appendChild( ns.firstChild );
		} catch(e) {
			alert( 'IO.xformin error: ' + e );
		}
	};

IO.xpath = function( xpath, doc ) {
		if (typeof doc == 'undefined') doc = document;
		var resolver = doc.createNSResolver(doc.documentElement);
		var xpathResult = doc.evaluate(
			xpath,
			doc,
			function lookupNamespaceURI (prefix) {
				var nsURI = null;
				switch (prefix) {
					case 'xul'	: nsURI = 'http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul'; break;
					case 'html'	: nsURI = 'http://www.w3.org/1999/xhtml'; break;
					case 'xsl'	: nsURI = 'http://www.w3.org/1999/XSL/Transform'; break;
					default		: nsURI = resolver.lookupNamespaceURI(prefix);
				}
				return nsURI;
			},
			XPathResult.ORDERED_NODE_ITERATOR_TYPE,
			null
		);
		var result = new Array();
		var node;
		while ((node = xpathResult.iterateNext())) { result.push( node ) }
		return result;
	};

IO.string2clipboard = function(data) {
		var e;
		try {
			if (typeof data == 'string') Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper).copyString(data);
		} catch(e) {
			IO.dump( 'IO.string2clipboard: ' + e);
			throw(e);
		}
	};

IO.clipboard2String = function() {
		var e;
		try {
			var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);
			if (!clip) return false;
			var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
			if (!trans) return false;
			trans.addDataFlavor("text/unicode");
			clip.getData(trans,clip.kGlobalClipboard);
			var str = new Object();
			var strLength = new Object();
			trans.getTransferData("text/unicode",str,strLength);
			if (str) str = str.value.QueryInterface(Components.interfaces.nsISupportsString);
			return ( !! str ) ? str.data.substring( 0,strLength.value / 2) : '';
		} catch(e) {
			IO.dump( 'IO.clipboard2String: ' + e);
			throw(e);
		}
	};
	
IO.listWindows = function( wintype ) {
		var e;
		try {
			// wintype: "navigator:browser", ecc. "null" for every winwod type.
			if ( typeof wintype == 'undefined' ) wintype = null;
			var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
			var enumerator = wm.getEnumerator( wintype );
			var windows = new Array();
			while ( enumerator.hasMoreElements() ) {
				var win = enumerator.getNext();
				// |win| is [Object ChromeWindow] (just like |window|)
				windows.push( win );
			}
			return windows;
		} catch(e) {
			IO.dump( 'IO.listWindows: ' + e);
			throw(e);
		}
	};

IO.getWindowByName = function( wname, wtype ) {
		var e;
		try {
			if ( typeof wname == 'undefined' ) return false;
			if ( typeof wtype == 'undefined' ) wtype = null;
			var wins = IO.listWindows( wtype );
			for ( var i = 0; i < wins.length; i++ ) if ( wins[i] ) if ( wins[i].name ) if ( wins[i].name == wname ) return wins[i];
			return false;
		} catch(e) {
			IO.dump( 'IO.getWindowByName: ' + e);
			throw(e);
		}
	};

IO.internal.promptService = function() {
		return Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	};

IO.alert = function( title, message) {
		var e;
		try {
			var prompts = IO.internal.promptService();
			prompts.alert( window, title, message );
		} catch(e) {
			alert(message);
		}
	};

IO.alertCheck = function( title, message, checkMessage, preChecked ) {
		var e;
		try {
			if ( typeof preChecked == 'undefined' ) preChecked = false;
			var check = { 'value' : preChecked };
			var promptService = IO.internal.promptService();
			promptService.alertCheck( window, title, message, checkMessage, check );
			return check.value;
		} catch(e) {
			alert(message);
			return preChecked;
		}
	};

IO.confirm = function( title, message) {
		var e;
		try {
			var promptService = IO.internal.promptService();
			return promptService.confirm( window, title, message );
		} catch(e) {
			return confirm(message);
		}
	};

IO.confirmCheck = function( title, message, checkMessage, preChecked ) {
		var e;
		try {
			if ( typeof preChecked == 'undefined' ) preChecked = false;
			var check = { 'value' : preChecked };
			var promptService = IO.internal.promptService();
			var response = promptService.confirmCheck( window, title, message, checkMessage, check );
			return [ response, check.value ];
		} catch(e) {
			return [ confirm(message), preChecked ];
		}
	};

IO.prompt = function( title, message, defaultText, checkMessage, preChecked ) {
		var e;
		try {
			if ( typeof checkMessage == 'undefined' ) {
				checkMessage = null;
				preChecked = null;
			} else {
				if ( typeof preChecked == 'undefined' ) preChecked = false;
			}
			var check = { 'value' : preChecked };
			if ( typeof defaultText == 'undefined' ) defaultText = '';
			var returnText = { 'value' : defaultText };
			var promptService = IO.internal.promptService();
			var response = promptService.prompt( window, title, message, returnText, checkMessage, check );
			return [ response, returnText.value, check.value ];
		} catch(e) {
			return [ true, prompt(message), preChecked ];
		}
	};

IO.quit = function(forceQuit) {
		var appStartup = Components.classes['@mozilla.org/toolkit/app-startup;1'].getService(Components.interfaces.nsIAppStartup);
		// eAttemptQuit will try to close each XUL window, but the XUL window can cancel the quit
		// process if there is unsaved data. eForceQuit will quit no matter what.
		var quitSeverity = forceQuit ? Components.interfaces.nsIAppStartup.eForceQuit : Components.interfaces.nsIAppStartup.eAttemptQuit;
		appStartup.quit(quitSeverity);
	};

IO.event = new Object();

IO.event.change = function( node ) {
		var evt = node.ownerDocument.createEvent('HTMLEvents');
		evt.initEvent('change', true, true );
		node.dispatchEvent( evt );
	};

IO.event.select = function( node ) {
		var evt = node.ownerDocument.createEvent('HTMLEvents');
		evt.initEvent('select', true, true );
		node.dispatchEvent( evt );
	};

IO.event.focus = function( node ) {
		var evt = node.ownerDocument.createEvent('UIEvents');
		evt.initUIEvent('DOMFocusIn', true, true );
		node.dispatchEvent( evt );
	};

IO.event.blur = function( node ) {
		var evt = node.ownerDocument.createEvent('UIEvents');
		evt.initUIEvent('DOMFocusOut', true, true );
		node.dispatchEvent( evt );
	};

IO.event.activate = function( node ) {
		var evt = node.ownerDocument.createEvent('UIEvents');
		evt.initUIEvent('DOMActivate', true, true );
		node.dispatchEvent( evt );
	};

IO.event.click = function( node ) {
		var evt = node.ownerDocument.createEvent("MouseEvents");
		evt.initMouseEvent("click", true, true, node.ownerDocument.AbstractView, 0, 0, 0, 0, 0, false, false, false, false, 0, node);
		node.dispatchEvent( evt );
	};

IO.event.input = function( node ) {
		var evt = node.ownerDocument.createEvent("KeyboardEvent");
		evt.initKeyEvent("keypress", true, true, node.ownerDocument.AbstractView, false, false, false, false, 0, 0);
		node.dispatchEvent( evt );
	};
