var LIST = { 'internal' : new Object(), 'prop' : new Object() };

LIST.analyzePopup = function( popupObj, ev, itemNode, func, funcOnEmpty ) {
		XML.zapAllChilds( popupObj );
		if (typeof funcOnEmpty == 'undefined' ) funcOnEmpty = false;
		if ( itemNode.nodeName != 'listitem' ) {
			if ( funcOnEmpty ) {
				funcOnEmpty( popupObj, itemNode );
			} else {
				popupObj.appendChild( XML.createNode('menuitem','',{'label':'No command available'}, popupObj.ownerDocument) );
			}
		} else {
			func( popupObj, itemNode );
		}
	};

LIST.sortListbox = function( col, datatype, node ) {
		var e;
		try {
			while ( node.nodeName != 'listbox' ) { node = node.parentNode }
			if ( node.selectedCount > 0 ) node.clearSelection();
			var doc = IO.newXML();
			doc.documentElement.appendChild( node.cloneNode(true) );
			IO.xformin( doc, 'genericListSort.xsl', { 'sortKey' : col, 'sortType' : datatype, 'noroot' : 'Y' }, node );
			node.selectedIndex = 0;
			node.ensureIndexIsVisible(0);
		} catch(e) {
			IO.alert( 'LIST.sortListbox', e );
		}
	};

LIST.appendPopupChildren = function(orig, dest) {
		var e;
		try {
			orig = XML.getElementChilds( orig );
			for (var i=0; i < orig.length; i++) dest.appendChild( orig[i].cloneNode(true) );
		} catch(e) {
			IO.alert( 'LIST.appendPopupItems', e );
		}
	};

LIST.populatePopups = function() {
		var e;
		try {
			var x = IO.getUserChrome();
			x = x.path + IO.prop.sep + 'data';
			IO.mkdir( x );
			x += IO.prop.sep + 'lookup';
			IO.mkdir( x );
			x += IO.prop.sep;
			LIST.prop.lookupdir = x;
			var pops = IO.xpath( '//xul:menupopup[@source]', document );
			for ( var i = 0; i < pops.length; i++ ) LIST.internal.populatePopup( pops[i] );
		} catch(e) {
			IO.alert( 'LIST.populatePopups', e );
		}
	};

window.addEventListener( 'load', LIST.populatePopups, false );

LIST.populateSinglePopup = function( popupObj ){ LIST.internal.populatePopup( popupObj ); };
	
LIST.internal.populatePopup = function( popupObj, doc ) {
		var e;
		try {
			var tag = popupObj.getAttribute('source');
			var prm = popupObj.hasAttribute('hparm') ? popupObj.getAttribute('hparm') : '';
			var live = popupObj.hasAttribute('live') ? true : false;
			if ( doc ) {
				if (!live ) if ( (prm + tag) != '') IO.write(  tag + prm + '.xml', doc, LIST.prop.lookupdir );
			} else {
				try {
					if ( live ) throw('leggi!');
					doc = IO.readXML( tag + prm + '.xml', LIST.prop.lookupdir );
				} catch(e) {
					var d = new AJAX.doc();
					var c = d.newCommand('getLookup', tag);
					c.newParam( 'cxml', tag );
					c.newParam('HPARM', prm);
					d.send( function(doc) { LIST.internal.populatePopup( popupObj, doc) } , false );
					return;
				}
			}
			var pars = {
					'firstNull'	: popupObj.hasAttribute('firstNull') && ( popupObj.getAttribute('firstNull') == 'true' ) ? 'Y' : 'N',
					'sortByText'	: popupObj.hasAttribute('sortByText') ? popupObj.getAttribute('sortByText') : '',
					'sortByNum'	: popupObj.hasAttribute('sortByNum') ? popupObj.getAttribute('sortByNum') : '' ,
					'itemCommand'	: popupObj.hasAttribute('itemCommand') ? popupObj.getAttribute('itemCommand') : ''
				};
			IO.xformin( doc, 'results2menuitems.xsl', pars, popupObj );
			var pp = popupObj.parentNode;
			if (pp) if ( pp.nodeName == 'menulist' ) {
				if ( pp.hasAttribute('selectedIndex') ) {
					pp.addEventListener("ValueChange", LIST.internal.evHselectedIndex, false);
					pp.selectedIndex = pp.getAttribute('selectedIndex');
				} else if ( pp.hasAttribute('value') ) {
					pp.addEventListener("ValueChange", LIST.internal.evHvalue, false);
					pp.value = pp.getAttribute('value');
				}
				if ( ! (pp.selectedItem) ) pp.selectedIndex = 0;
			}
			if ( popupObj.hasAttribute('collapseIfOne') ) {
				var contbox = popupObj.ownerDocument.getElementById( popupObj.getAttribute('collapseIfOne') );
				if ( contbox ) contbox.setAttribute( 'collapsed', ( XML.getChildrenByName( popupObj, 'menuitem').length < 2 ) );
			}
		} catch(e) {
			IO.alert( 'LIST.populateListFromXml', e );
		}
	};

LIST.internal.evHselectedIndex = function( ev ) { ev.currentTarget.setAttribute('selectedIndex', ev.currentTarget.selectedIndex ) };
LIST.internal.evHvalue = function( ev ) { ev.currentTarget.setAttribute('value', ev.currentTarget.value ) };
