/*
	© 2008 M. Balestra e F. Manzo
	
	Pre-requisites:
		XML object (library), IO object (library).
		AJAX object (library)
*/
var LOGIN = { 'internal' : new Object() };

LOGIN.logout = function( clearLogin ) {
		AJAX.logout()
		if ( clearLogin ) AJAX.clearLogin();
	};

LOGIN.login = function ( user, pass, fOK, fKO ) {
		AJAX.setStatus('preLogin');
		AJAX.setBusy( true );
		var url = AJAX.getLoginUri();
		var f_ok = function(doc) { LOGIN.internal.login( doc, user, pass, fOK, fKO ) };
		var f_ko = function(){ LOGIN.internal.loginKO( fKO ) };
		XML.load( url, f_ok, f_ko, false );
	};

LOGIN.internal.loginKO = function( fKO ) {
		AJAX.setStatus('errNoLoginS');
		AJAX.setBusy( false );
		fKO();
	}

LOGIN.internal.login = function( doc, user, pass, fOK, fKO ) {
		AJAX.setStatus('loginInProg');
		AJAX.setBusy( true );
		var f_ok = function(doc) { LOGIN.internal.loginDo(doc, fOK, fKO) };
		var f_ko = function(){ LOGIN.internal.loginDoKO(fKO) };
		if ( doc.documentElement.hasAttribute('goto') ) {
			var url = doc.documentElement.getAttribute('goto');
			var doc = IO.newXML();
			doc.documentElement.setAttribute( 'user', user );
			doc.documentElement.setAttribute( 'password', pass );
			XML.post( url, f_ok, doc, f_ko, false );
		} else if ( doc.documentElement.hasAttribute('kerb') ) {
			var url = doc.documentElement.getAttribute('kerb');
			var urlp = url.split('://');
			url = urlp[0] + '://' + encodeURIComponent(user) + ':' + encodeURIComponent(pass) + '@' + urlp[1];
			XML.load( url, f_ok, f_ko, false );
		} else {
			f_ko();
		}
	};

LOGIN.internal.loginDoKO = function(fKO) {
		AJAX.setStatus('loginError');
		AJAX.setBusy( false );
		fKO();
	}

LOGIN.internal.loginDo = function( doc, fOK, fKO ) {
		var root = doc.documentElement;
		AJAX.setBusy( false );
		if ( parseInt(root.getAttribute('auth')) == 1 ) {
			AJAX.setUser( root.getAttribute('user') );
			AJAX.setSession( root.getAttribute('session') );
			AJAX.setUri( root.getAttribute('ajax') );
			AJAX.setDocumentsUri( root.getAttribute('docs') );
			if ( root.hasAttribute('lookup') ) {
				var newv = parseFloat( root.getAttribute('lookup') );
				var oldv = parseFloat( IO.getPref('thisapp.lookup.build') );
				if (isNaN( oldv)) oldv = 0;
				if ( newv > oldv ) {
					var x = IO.getUserChrome();
					x = x.path + IO.prop.sep + 'data';
					IO.mkdir( x );
					x += IO.prop.sep + 'lookup';
					IO.rmdir( x, '', true, true );
					IO.setPref('thisapp.lookup.build', String(newv));
				}
			}
			AJAX.setStatus('loginOK');
			fOK();
		} else {
			AJAX.setStatus('loginKO');
			fKO();
		}
	};
