<?xml version="1.0" encoding="utf-8"?>

<!DOCTYPE xsl:stylesheet [
]>

<xsl:stylesheet
	version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
	>

	<xsl:output method="xml" version="1.0" encoding="utf-8" indent="yes" />
	
	<xsl:param name="topFilterAttribute" select="''" />
	<xsl:param name="topFilterValue" select="''" />
	<xsl:param name="topFilterSkip" select="''" />
	<xsl:param name="openState" select="'true'" />
	
	<xsl:template match="root">
		<xsl:apply-templates select="arrayitem/results" />
	</xsl:template>
	
	<xsl:template match="results">
		<treechildren>
			<xsl:for-each select="arrayitem[@kparent='']">
				<xsl:choose>
					<xsl:when test="string-length($topFilterAttribute)=0">
						<xsl:apply-templates select="." />
					</xsl:when>
					<xsl:when test="@*[name()=$topFilterAttribute]=$topFilterValue">
						<xsl:choose>
							<xsl:when test="string-length($topFilterSkip)!=0">
								<xsl:variable name="thisKnode" select="@knode" />
								<xsl:apply-templates select="../arrayitem[@kparent=$thisKnode]" />
							</xsl:when>
							<xsl:otherwise>
								<xsl:apply-templates select="." />
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
				</xsl:choose>
			</xsl:for-each>
<!-- 
			<xsl:apply-templates select="arrayitem[@kparent='']" />
 -->
		</treechildren>
	</xsl:template>
	
	<xsl:template match="arrayitem">
		<xsl:variable name="thisKnode" select="@knode" />
		<xsl:variable name="children" select="../arrayitem[@kparent=$thisKnode]" />
		<treeitem value="{@knode}" cmask="{@cmask}" parent="{@kparent}">
			<xsl:if test="$children">
				<xsl:attribute name="container">true</xsl:attribute>
				<xsl:attribute name="open">
					<xsl:value-of select="$openState" />
				</xsl:attribute>
			</xsl:if>
			<treerow>
				<treecell label="{@snode}" properties="{@lproperties}">
					<xsl:if test="string-length(@stooltip)!=0">
						<xsl:attribute name="tooltiptext">
							<xsl:value-of select="@stooltip" />
						</xsl:attribute>
					</xsl:if>
				</treecell>
			</treerow>
			<xsl:if test="$children">
				<treechildren>
					<xsl:apply-templates select="$children" />
				</treechildren>
			</xsl:if>
		</treeitem>
	</xsl:template>
	
</xsl:stylesheet>
