<?xml version="1.0" encoding="utf-8"?>

<xsl:stylesheet
	version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xul="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
	xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
	>
	
	<xsl:output method="xml" version="1.0" encoding="utf-8" indent="yes" />
	
	<xsl:param name="sortIndex" select="1" />
	<xsl:param name="sortDir"   select="'ascending'" />
	<xsl:param name="sortField" select="'L'" />
	
	<xsl:template match="/root">
		<treechildren>
			<xsl:variable name="sortType">
				<xsl:choose>
					<xsl:when test="starts-with($sortField,'D')">text</xsl:when>
					<xsl:when test="starts-with($sortField,'U')">number</xsl:when>
					<xsl:when test="starts-with($sortField,'M')">number</xsl:when>
					<xsl:when test="starts-with($sortField,'K')">number</xsl:when>
					<xsl:otherwise>text</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:for-each select="*">
				<xsl:sort select="xul:treerow/*[$sortIndex]/@label" data-type="{$sortType}" order="{$sortDir}" />
				<xsl:copy-of select="." />
			</xsl:for-each>
		</treechildren>
	</xsl:template>
	 
</xsl:stylesheet>
