<?xml version="1.0" encoding="utf-8"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	
	<xsl:output method="xml" version="1.0" encoding="utf-8" indent="yes" />

	<xsl:param name="chanPrefix" select="''" />
	<xsl:param name="progPrefix" select="''" />
	<xsl:param name="xslPrefix"  select="''" />
	<xsl:param name="xulPrefix"  select="''" />
	
	<xsl:template match="/">
		<files>
			<xsl:apply-templates select="*" />
		</files>
	</xsl:template>
	
	<xsl:template match="*" />
	
	<xsl:template match="frame" priority="2">
		<xsl:apply-templates select="*" />
	</xsl:template>
	
	<xsl:template match="root" priority="2">
		<file id="{@id}" type="chan">
			<xsl:attribute name="name">
				<xsl:value-of select="concat($chanPrefix, @id, '.xml')" />
			</xsl:attribute>
		</file>
		<file id="{@id}" type="xul">
			<xsl:attribute name="name">
				<xsl:value-of select="concat($xulPrefix, @outlinetype, '.xul')" />
			</xsl:attribute>
		</file>
		<xsl:apply-templates select="@xsl" />
		<xsl:apply-templates select="*" />
	</xsl:template>

	<xsl:template match="program" priority="2">
		<file id="{@id}" type="prog">
			<xsl:attribute name="name">
				<xsl:value-of select="concat($progPrefix, @id, '.xml')" />
			</xsl:attribute>
		</file>
		<xsl:apply-templates select="@xsl" />
	</xsl:template>
	
	<xsl:template match="@xsl">
		<file id="{.}" type="xsl">
			<xsl:attribute name="name">
				<xsl:value-of select="concat($xslPrefix, ., '.xsl')" />
			</xsl:attribute>
		</file>
	</xsl:template>
	
</xsl:stylesheet>
